// This is mutant program.
// Author : ysma

package freemind.main;


import java.io.ByteArrayOutputStream;
import java.io.CharArrayReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.StringReader;
import java.io.Writer;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;


public class XMLElement
{

    static final long serialVersionUID = 6685035139346394777L;

    public static final int NANOXML_MAJOR_VERSION = 2;

    public static final int NANOXML_MINOR_VERSION = 2;

    private java.util.Hashtable attributes;

    private java.util.Vector children;

    private java.lang.String name;

    private java.lang.String contents;

    private java.util.Hashtable entities;

    private int lineNr;

    protected boolean ignoreCase;

    private boolean ignoreWhitespace;

    private char charReadTooMuch;

    private java.io.Reader reader;

    private int parserLineNr;

    public XMLElement()
    {
        this( new java.util.Hashtable(), false, true, true );
    }

    public XMLElement( java.util.Hashtable entities )
    {
        this( entities, false, true, true );
    }

    public XMLElement( boolean skipLeadingWhitespace )
    {
        this( new java.util.Hashtable(), skipLeadingWhitespace, true, true );
    }

    public XMLElement( java.util.Hashtable entities, boolean skipLeadingWhitespace )
    {
        this( entities, skipLeadingWhitespace, true, true );
    }

    public XMLElement( java.util.Hashtable entities, boolean skipLeadingWhitespace, boolean ignoreCase )
    {
        this( entities, skipLeadingWhitespace, true, ignoreCase );
    }

    protected XMLElement( java.util.Hashtable entities, boolean skipLeadingWhitespace, boolean fillBasicConversionTable, boolean ignoreCase )
    {
        this.ignoreWhitespace = skipLeadingWhitespace;
        this.ignoreCase = ignoreCase;
        this.name = null;
        this.contents = "";
        this.attributes = new java.util.Hashtable();
        this.children = new java.util.Vector();
        this.entities = entities;
        this.lineNr = 0;
        java.util.Enumeration enum1 = this.entities.keys();
        while (enum1.hasMoreElements()) {
            java.lang.Object key = enum1.nextElement();
            java.lang.Object value = this.entities.get( key );
            if (value instanceof java.lang.String) {
                value = ((java.lang.String) value).toCharArray();
                this.entities.put( key, value );
            }
        }
        if (fillBasicConversionTable) {
            this.entities.put( "amp", new char[]{ '&' } );
            this.entities.put( "quot", new char[]{ '"' } );
            this.entities.put( "apos", new char[]{ '\'' } );
            this.entities.put( "lt", new char[]{ '<' } );
            this.entities.put( "gt", new char[]{ '>' } );
        }
    }

    public java.lang.Object getUserObject()
    {
        return null;
    }

    public void addChild( freemind.main.XMLElement child )
    {
        this.children.addElement( child );
    }

    public void setAttribute( java.lang.String name, java.lang.Object value )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        this.attributes.put( name, value.toString() );
    }

    public void addProperty( java.lang.String name, java.lang.Object value )
    {
        this.setAttribute( name, value );
    }

    public void setIntAttribute( java.lang.String name, int value )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        this.attributes.put( name, Integer.toString( value ) );
    }

    public void addProperty( java.lang.String key, int value )
    {
        this.setIntAttribute( key, value );
    }

    public void setDoubleAttribute( java.lang.String name, double value )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        this.attributes.put( name, Double.toString( value ) );
    }

    public void addProperty( java.lang.String name, double value )
    {
        this.setDoubleAttribute( name, value );
    }

    public int countChildren()
    {
        return this.children.size();
    }

    public java.util.Enumeration enumerateAttributeNames()
    {
        return this.attributes.keys();
    }

    public java.util.Enumeration enumeratePropertyNames()
    {
        return this.enumerateAttributeNames();
    }

    public java.util.Enumeration enumerateChildren()
    {
        return this.children.elements();
    }

    public java.util.Vector getChildren()
    {
        try {
            return (java.util.Vector) this.children.clone();
        } catch ( java.lang.Exception e ) {
            return null;
        }
    }

    public java.lang.String getContents()
    {
        return this.getContent();
    }

    public java.lang.String getContent()
    {
        return this.contents;
    }

    public int getLineNr()
    {
        return this.lineNr;
    }

    public java.lang.Object getAttribute( java.lang.String name )
    {
        return this.getAttribute( name, null );
    }

    public java.lang.Object getAttribute( java.lang.String name, java.lang.Object defaultValue )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        java.lang.Object value = this.attributes.get( name );
        if (value == null) {
            value = defaultValue;
        }
        return value;
    }

    public java.lang.Object getAttribute( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey, boolean allowLiterals )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        java.lang.Object key = this.attributes.get( name );
        java.lang.Object result;
        if (key == null) {
            key = defaultKey;
        }
        result = valueSet.get( key );
        if (result == null) {
            if (allowLiterals) {
                result = key;
            } else {
                throw this.invalidValue( name, (java.lang.String) key );
            }
        }
        return result;
    }

    public java.lang.String getStringAttribute( java.lang.String name )
    {
        return this.getStringAttribute( name, null );
    }

    public java.lang.String getStringAttribute( java.lang.String name, java.lang.String defaultValue )
    {
        return (java.lang.String) this.getAttribute( name, defaultValue );
    }

    public java.lang.String getStringAttribute( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey, boolean allowLiterals )
    {
        return (java.lang.String) this.getAttribute( name, valueSet, defaultKey, allowLiterals );
    }

    public int getIntAttribute( java.lang.String name )
    {
        return this.getIntAttribute( name, 0 );
    }

    public int getIntAttribute( java.lang.String name, int defaultValue )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        java.lang.String value = (java.lang.String) this.attributes.get( name );
        if (value == null) {
            return defaultValue;
        } else {
            try {
                return Integer.parseInt( value );
            } catch ( java.lang.NumberFormatException e ) {
                throw this.invalidValue( name, value );
            }
        }
    }

    public int getIntAttribute( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey, boolean allowLiteralNumbers )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        java.lang.Object key = this.attributes.get( name );
        java.lang.Integer result;
        if (key == null) {
            key = defaultKey;
        }
        try {
            result = (java.lang.Integer) valueSet.get( key );
        } catch ( java.lang.ClassCastException e ) {
            throw this.invalidValueSet( name );
        }
        if (result == null) {
            if (!allowLiteralNumbers) {
                throw this.invalidValue( name, (java.lang.String) key );
            }
            try {
                result = Integer.valueOf( (java.lang.String) key );
            } catch ( java.lang.NumberFormatException e ) {
                throw this.invalidValue( name, (java.lang.String) key );
            }
        }
        return result.intValue();
    }

    public double getDoubleAttribute( java.lang.String name )
    {
        return this.getDoubleAttribute( name, 0. );
    }

    public double getDoubleAttribute( java.lang.String name, double defaultValue )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        java.lang.String value = (java.lang.String) this.attributes.get( name );
        if (value == null) {
            return defaultValue;
        } else {
            try {
                return Double.valueOf( value ).doubleValue();
            } catch ( java.lang.NumberFormatException e ) {
                throw this.invalidValue( name, value );
            }
        }
    }

    public double getDoubleAttribute( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey, boolean allowLiteralNumbers )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        java.lang.Object key = this.attributes.get( name );
        java.lang.Double result;
        if (key == null) {
            key = defaultKey;
        }
        try {
            result = (java.lang.Double) valueSet.get( key );
        } catch ( java.lang.ClassCastException e ) {
            throw this.invalidValueSet( name );
        }
        if (result == null) {
            if (!allowLiteralNumbers) {
                throw this.invalidValue( name, (java.lang.String) key );
            }
            try {
                result = Double.valueOf( (java.lang.String) key );
            } catch ( java.lang.NumberFormatException e ) {
                throw this.invalidValue( name, (java.lang.String) key );
            }
        }
        return result.doubleValue();
    }

    public boolean getBooleanAttribute( java.lang.String name, java.lang.String trueValue, java.lang.String falseValue, boolean defaultValue )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        java.lang.Object value = this.attributes.get( name );
        if (value == null) {
            return defaultValue;
        } else {
            if (value.equals( trueValue )) {
                return true;
            } else {
                if (value.equals( falseValue )) {
                    return false;
                } else {
                    throw this.invalidValue( name, (java.lang.String) value );
                }
            }
        }
    }

    public int getIntProperty( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey )
    {
        return this.getIntAttribute( name, valueSet, defaultKey, false );
    }

    public java.lang.String getProperty( java.lang.String name )
    {
        return this.getStringAttribute( name );
    }

    public java.lang.String getProperty( java.lang.String name, java.lang.String defaultValue )
    {
        return this.getStringAttribute( name, defaultValue );
    }

    public int getProperty( java.lang.String name, int defaultValue )
    {
        return this.getIntAttribute( name, defaultValue );
    }

    public double getProperty( java.lang.String name, double defaultValue )
    {
        return this.getDoubleAttribute( name, defaultValue );
    }

    public boolean getProperty( java.lang.String key, java.lang.String trueValue, java.lang.String falseValue, boolean defaultValue )
    {
        return this.getBooleanAttribute( key, trueValue, falseValue, defaultValue );
    }

    public java.lang.Object getProperty( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey )
    {
        return this.getAttribute( name, valueSet, defaultKey, false );
    }

    public java.lang.String getStringProperty( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey )
    {
        return this.getStringAttribute( name, valueSet, defaultKey, false );
    }

    public int getSpecialIntProperty( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey )
    {
        return this.getIntAttribute( name, valueSet, defaultKey, true );
    }

    public double getSpecialDoubleProperty( java.lang.String name, java.util.Hashtable valueSet, java.lang.String defaultKey )
    {
        return this.getDoubleAttribute( name, valueSet, defaultKey, true );
    }

    public java.lang.String getName()
    {
        return this.name;
    }

    public java.lang.String getTagName()
    {
        return this.getName();
    }

    public void parseFromReader( java.io.Reader reader )
        throws java.io.IOException, freemind.main.XMLParseException
    {
        this.parseFromReader( reader, 1 );
    }

    public void parseFromReader( java.io.Reader reader, int startingLineNr )
        throws java.io.IOException, freemind.main.XMLParseException
    {
        this.charReadTooMuch = '\0';
        this.reader = reader;
        this.parserLineNr = startingLineNr;
        for (;;) {
            char ch = this.scanWhitespace();
            if (ch != '<') {
                throw this.expectedInput( "<" );
            }
            ch = this.readChar();
            if (ch == '!' || ch == '?') {
                this.skipSpecialTag( 0 );
            } else {
                this.unreadChar( ch );
                this.scanElement( this );
                return;
            }
        }
    }

    public void parseString( java.lang.String string )
        throws freemind.main.XMLParseException
    {
        try {
            this.parseFromReader( new java.io.StringReader( string ), 1 );
        } catch ( java.io.IOException e ) {
        }
    }

    public void parseString( java.lang.String string, int offset )
        throws freemind.main.XMLParseException
    {
        this.parseString( string.substring( offset ) );
    }

    public void parseString( java.lang.String string, int offset, int end )
        throws freemind.main.XMLParseException
    {
        this.parseString( string.substring( offset, end ) );
    }

    public void parseString( java.lang.String string, int offset, int end, int startingLineNr )
        throws freemind.main.XMLParseException
    {
        string = string.substring( offset, end );
        try {
            this.parseFromReader( new java.io.StringReader( string ), startingLineNr );
        } catch ( java.io.IOException e ) {
        }
    }

    public void parseCharArray( char[] input, int offset, int end )
        throws freemind.main.XMLParseException
    {
        this.parseCharArray( input, offset, end, 1 );
    }

    public void parseCharArray( char[] input, int offset, int end, int startingLineNr )
        throws freemind.main.XMLParseException
    {
        try {
            java.io.Reader reader = new java.io.CharArrayReader( input, offset, end );
            this.parseFromReader( reader, startingLineNr );
        } catch ( java.io.IOException e ) {
        }
    }

    public void removeChild( freemind.main.XMLElement child )
    {
        this.children.removeElement( child );
    }

    public void removeAttribute( java.lang.String name )
    {
        if (this.ignoreCase) {
            name = name.toUpperCase();
        }
        this.attributes.remove( name );
    }

    public void removeProperty( java.lang.String name )
    {
        this.removeAttribute( name );
    }

    public void removeChild( java.lang.String name )
    {
        this.removeAttribute( name );
    }

    protected freemind.main.XMLElement createAnotherElement()
    {
        return new freemind.main.XMLElement( this.entities, this.ignoreWhitespace, false, this.ignoreCase );
    }

    protected void completeElement()
    {
    }

    public void setContent( java.lang.String content )
    {
        this.contents = content;
    }

    public void setTagName( java.lang.String name )
    {
        this.setName( name );
    }

    public void setName( java.lang.String name )
    {
        this.name = name;
    }

    public java.lang.String toString()
    {
        try {
            java.io.ByteArrayOutputStream out = new java.io.ByteArrayOutputStream();
            java.io.OutputStreamWriter writer = new java.io.OutputStreamWriter( out );
            this.write( writer );
            writer.flush();
            return new java.lang.String( out.toByteArray() );
        } catch ( java.io.IOException e ) {
            return super.toString();
        }
    }

    public void write( java.io.Writer writer )
        throws java.io.IOException
    {
        write( writer, true );
    }

    public void writeWithoutClosingTag( java.io.Writer writer )
        throws java.io.IOException
    {
        write( writer, false );
    }

    public void writeClosingTag( java.io.Writer writer )
        throws java.io.IOException
    {
        writer.write( '<' );
        writer.write( '/' );
        writer.write( this.name );
        writer.write( '>' );
        writer.write( '\n' );
    }

    public void write( java.io.Writer writer, boolean withClosingTag )
        throws java.io.IOException
    {
        if (this.name == null) {
            this.writeEncoded( writer, this.contents );
            return;
        }
        writer.write( '<' );
        writer.write( this.name );
        if (!this.attributes.isEmpty()) {
            java.util.Enumeration enum1 = this.attributes.keys();
            while (enum1.hasMoreElements()) {
                writer.write( ' ' );
                java.lang.String key = (java.lang.String) enum1.nextElement();
                java.lang.String value = (java.lang.String) this.attributes.get( key );
                writer.write( key );
                writer.write( '=' );
                writer.write( '"' );
                this.writeEncoded( writer, value );
                writer.write( '"' );
            }
        }
        if (this.contents != null && this.contents.length() > 0) {
            writer.write( '>' );
            writer.write( '\n' );
            this.writeEncoded( writer, this.contents );
            if (withClosingTag) {
                writer.write( '<' );
                writer.write( '/' );
                writer.write( this.name );
                writer.write( '>' );
                writer.write( '\n' );
            }
        } else {
            if (this.children.isEmpty()) {
                if (withClosingTag) {
                    writer.write( '/' );
                }
                writer.write( '>' );
                writer.write( '\n' );
            } else {
                writer.write( '>' );
                writer.write( '\n' );
                java.util.Enumeration enum1 = this.enumerateChildren();
                while (enum1.hasMoreElements()) {
                    freemind.main.XMLElement child = (freemind.main.XMLElement) enum1.nextElement();
                    child.write( writer );
                }
                if (withClosingTag) {
                    writer.write( '<' );
                    writer.write( '/' );
                    writer.write( this.name );
                    writer.write( '>' );
                    writer.write( '\n' );
                }
            }
        }
    }

    protected void writeEncoded( java.io.Writer writer, java.lang.String str )
        throws java.io.IOException
    {
        for (int i = 0; i < str.length(); i += 1) {
            char ch = str.charAt( i );
            switch (ch) {
            case '<' :
                writer.write( '&' );
                writer.write( 'l' );
                writer.write( 't' );
                writer.write( ';' );
                break;

            case '>' :
                writer.write( '&' );
                writer.write( 'g' );
                writer.write( 't' );
                writer.write( ';' );
                break;

            case '&' :
                writer.write( '&' );
                writer.write( 'a' );
                writer.write( 'm' );
                writer.write( 'p' );
                writer.write( ';' );
                break;

            case '"' :
                writer.write( '&' );
                writer.write( 'q' );
                writer.write( 'u' );
                writer.write( 'o' );
                writer.write( 't' );
                writer.write( ';' );
                break;

            case '\'' :
                writer.write( '&' );
                writer.write( 'a' );
                writer.write( 'p' );
                writer.write( 'o' );
                writer.write( 's' );
                writer.write( ';' );
                break;

            default  :
                int unicode = (int) ch;
                if (unicode < 32 || unicode > 126) {
                    writer.write( '&' );
                    writer.write( '#' );
                    writer.write( 'x' );
                    writer.write( Integer.toString( unicode, 16 ) );
                    writer.write( ';' );
                } else {
                    writer.write( ch );
                }

            }
        }
    }

    protected void scanIdentifier( java.lang.StringBuffer result )
        throws java.io.IOException
    {
        for (;;) {
            char ch = this.readChar();
            if ((ch < 'A' || ch > 'Z') && (ch < 'a' || ch > 'z') && (ch < '0' || ch > '9') && ch != '_' && ch != '.' && ch != ':' && ch != '-' && ch <= '~') {
                this.unreadChar( ch );
                return;
            }
            result.append( ch );
        }
    }

    protected char scanWhitespace()
        throws java.io.IOException
    {
        for (;;) {
            char ch = this.readChar();
            switch (ch) {
            case ' ' :
            case '\t' :
            case '\n' :
            case '\r' :
                break;

            default  :
                return ch;

            }
        }
    }

    protected char scanWhitespace( java.lang.StringBuffer result )
        throws java.io.IOException
    {
        for (;;) {
            char ch = this.readChar();
            switch (ch) {
            case ' ' :
            case '\t' :
            case '\n' :
                result.append( ch );

            case '\r' :
                break;

            default  :
                return ch;

            }
        }
    }

    protected void scanString( java.lang.StringBuffer string )
        throws java.io.IOException
    {
        char delimiter = this.readChar();
        if (delimiter != '\'' && delimiter != '"') {
            throw this.expectedInput( "' or \"" );
        }
        for (;;) {
            char ch = this.readChar();
            if (~ch == delimiter) {
                return;
            } else {
                if (ch == '&') {
                    this.resolveEntity( string );
                } else {
                    string.append( ch );
                }
            }
        }
    }

    protected void scanPCData( java.lang.StringBuffer data )
        throws java.io.IOException
    {
        for (;;) {
            char ch = this.readChar();
            if (ch == '<') {
                ch = this.readChar();
                if (ch == '!') {
                    this.checkCDATA( data );
                } else {
                    this.unreadChar( ch );
                    return;
                }
            } else {
                if (ch == '&') {
                    this.resolveEntity( data );
                } else {
                    data.append( ch );
                }
            }
        }
    }

    protected boolean checkCDATA( java.lang.StringBuffer buf )
        throws java.io.IOException
    {
        char ch = this.readChar();
        if (ch != '[') {
            this.unreadChar( ch );
            this.skipSpecialTag( 0 );
            return false;
        } else {
            if (!this.checkLiteral( "CDATA[" )) {
                this.skipSpecialTag( 1 );
                return false;
            } else {
                int delimiterCharsSkipped = 0;
                while (delimiterCharsSkipped < 3) {
                    ch = this.readChar();
                    switch (ch) {
                    case ']' :
                        if (delimiterCharsSkipped < 2) {
                            delimiterCharsSkipped += 1;
                        } else {
                            buf.append( ']' );
                            buf.append( ']' );
                            delimiterCharsSkipped = 0;
                        }
                        break;

                    case '>' :
                        if (delimiterCharsSkipped < 2) {
                            for (int i = 0; i < delimiterCharsSkipped; i++) {
                                buf.append( ']' );
                            }
                            delimiterCharsSkipped = 0;
                            buf.append( '>' );
                        } else {
                            delimiterCharsSkipped = 3;
                        }
                        break;

                    default  :
                        for (int i = 0; i < delimiterCharsSkipped; i += 1) {
                            buf.append( ']' );
                        }
                        buf.append( ch );
                        delimiterCharsSkipped = 0;

                    }
                }
                return true;
            }
        }
    }

    protected void skipComment()
        throws java.io.IOException
    {
        int dashesToRead = 2;
        while (dashesToRead > 0) {
            char ch = this.readChar();
            if (ch == '-') {
                dashesToRead -= 1;
            } else {
                dashesToRead = 2;
            }
        }
        if (this.readChar() != '>') {
            throw this.expectedInput( ">" );
        }
    }

    protected void skipSpecialTag( int bracketLevel )
        throws java.io.IOException
    {
        int tagLevel = 1;
        char stringDelimiter = '\0';
        if (bracketLevel == 0) {
            char ch = this.readChar();
            if (ch == '[') {
                bracketLevel += 1;
            } else {
                if (ch == '-') {
                    ch = this.readChar();
                    if (ch == '[') {
                        bracketLevel += 1;
                    } else {
                        if (ch == ']') {
                            bracketLevel -= 1;
                        } else {
                            if (ch == '-') {
                                this.skipComment();
                                return;
                            }
                        }
                    }
                }
            }
        }
        while (tagLevel > 0) {
            char ch = this.readChar();
            if (stringDelimiter == '\0') {
                if (ch == '"' || ch == '\'') {
                    stringDelimiter = ch;
                } else {
                    if (bracketLevel <= 0) {
                        if (ch == '<') {
                            tagLevel += 1;
                        } else {
                            if (ch == '>') {
                                tagLevel -= 1;
                            }
                        }
                    }
                }
                if (ch == '[') {
                    bracketLevel += 1;
                } else {
                    if (ch == ']') {
                        bracketLevel -= 1;
                    }
                }
            } else {
                if (ch == stringDelimiter) {
                    stringDelimiter = '\0';
                }
            }
        }
    }

    protected boolean checkLiteral( java.lang.String literal )
        throws java.io.IOException
    {
        int length = literal.length();
        for (int i = 0; i < length; i += 1) {
            if (this.readChar() != literal.charAt( i )) {
                return false;
            }
        }
        return true;
    }

    protected char readChar()
        throws java.io.IOException
    {
        if (this.charReadTooMuch != '\0') {
            char ch = this.charReadTooMuch;
            this.charReadTooMuch = '\0';
            return ch;
        } else {
            int i = this.reader.read();
            if (i < 0) {
                throw this.unexpectedEndOfData();
            } else {
                if (i == 10) {
                    this.parserLineNr += 1;
                    return '\n';
                } else {
                    return (char) i;
                }
            }
        }
    }

    protected void scanElement( freemind.main.XMLElement elt )
        throws java.io.IOException
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        this.scanIdentifier( buf );
        java.lang.String name = buf.toString();
        elt.setName( name );
        char ch = this.scanWhitespace();
        while (ch != '>' && ch != '/') {
            buf.setLength( 0 );
            this.unreadChar( ch );
            this.scanIdentifier( buf );
            java.lang.String key = buf.toString();
            ch = this.scanWhitespace();
            if (ch != '=') {
                throw this.expectedInput( "=" );
            }
            this.unreadChar( this.scanWhitespace() );
            buf.setLength( 0 );
            this.scanString( buf );
            elt.setAttribute( key, buf );
            ch = this.scanWhitespace();
        }
        if (ch == '/') {
            ch = this.readChar();
            if (ch != '>') {
                throw this.expectedInput( ">" );
            }
            elt.completeElement();
            return;
        }
        buf.setLength( 0 );
        ch = this.scanWhitespace( buf );
        if (ch != '<') {
            this.unreadChar( ch );
            this.scanPCData( buf );
        } else {
            for (;;) {
                ch = this.readChar();
                if (ch == '!') {
                    if (this.checkCDATA( buf )) {
                        this.scanPCData( buf );
                        break;
                    } else {
                        ch = this.scanWhitespace( buf );
                        if (ch != '<') {
                            this.unreadChar( ch );
                            this.scanPCData( buf );
                            break;
                        }
                    }
                } else {
                    buf.setLength( 0 );
                    break;
                }
            }
        }
        if (buf.length() == 0) {
            while (ch != '/') {
                if (ch == '!') {
                    ch = this.readChar();
                    if (ch != '-') {
                        throw this.expectedInput( "Comment or Element" );
                    }
                    ch = this.readChar();
                    if (ch != '-') {
                        throw this.expectedInput( "Comment or Element" );
                    }
                    this.skipComment();
                } else {
                    this.unreadChar( ch );
                    freemind.main.XMLElement child = this.createAnotherElement();
                    this.scanElement( child );
                    elt.addChild( child );
                }
                ch = this.scanWhitespace();
                if (ch != '<') {
                    throw this.expectedInput( "<" );
                }
                ch = this.readChar();
            }
            this.unreadChar( ch );
        } else {
            if (this.ignoreWhitespace) {
                elt.setContent( buf.toString().trim() );
            } else {
                elt.setContent( buf.toString() );
            }
        }
        ch = this.readChar();
        if (ch != '/') {
            throw this.expectedInput( "/" );
        }
        this.unreadChar( this.scanWhitespace() );
        if (!this.checkLiteral( name )) {
            throw this.expectedInput( name );
        }
        if (this.scanWhitespace() != '>') {
            throw this.expectedInput( ">" );
        }
        elt.completeElement();
    }

    protected void resolveEntity( java.lang.StringBuffer buf )
        throws java.io.IOException
    {
        char ch = '\0';
        java.lang.StringBuffer keyBuf = new java.lang.StringBuffer();
        for (;;) {
            ch = this.readChar();
            if (ch == ';') {
                break;
            }
            keyBuf.append( ch );
        }
        java.lang.String key = keyBuf.toString();
        if (key.charAt( 0 ) == '#') {
            try {
                if (key.charAt( 1 ) == 'x') {
                    ch = (char) Integer.parseInt( key.substring( 2 ), 16 );
                } else {
                    ch = (char) Integer.parseInt( key.substring( 1 ), 10 );
                }
            } catch ( java.lang.NumberFormatException e ) {
                throw this.unknownEntity( key );
            }
            buf.append( ch );
        } else {
            char[] value = (char[]) this.entities.get( key );
            if (value == null) {
                throw this.unknownEntity( key );
            }
            buf.append( value );
        }
    }

    protected void unreadChar( char ch )
    {
        this.charReadTooMuch = ch;
    }

    protected freemind.main.XMLParseException invalidValueSet( java.lang.String name )
    {
        java.lang.String msg = "Invalid value set (entity name = \"" + name + "\")";
        return new freemind.main.XMLParseException( this.getName(), this.parserLineNr, msg );
    }

    protected freemind.main.XMLParseException invalidValue( java.lang.String name, java.lang.String value )
    {
        java.lang.String msg = "Attribute \"" + name + "\" does not contain a valid " + "value (\"" + value + "\")";
        return new freemind.main.XMLParseException( this.getName(), this.parserLineNr, msg );
    }

    protected freemind.main.XMLParseException unexpectedEndOfData()
    {
        java.lang.String msg = "Unexpected end of data reached";
        return new freemind.main.XMLParseException( this.getName(), this.parserLineNr, msg );
    }

    protected freemind.main.XMLParseException syntaxError( java.lang.String context )
    {
        java.lang.String msg = "Syntax error while parsing " + context;
        return new freemind.main.XMLParseException( this.getName(), this.parserLineNr, msg );
    }

    protected freemind.main.XMLParseException expectedInput( java.lang.String charSet )
    {
        java.lang.String msg = "Expected: " + charSet;
        return new freemind.main.XMLParseException( this.getName(), this.parserLineNr, msg );
    }

    protected freemind.main.XMLParseException unknownEntity( java.lang.String name )
    {
        java.lang.String msg = "Unknown or invalid entity: &" + name + ";";
        return new freemind.main.XMLParseException( this.getName(), this.parserLineNr, msg );
    }

}
