// This is mutant program.
// Author : ysma

package freemind.controller;


import freemind.view.mindmapview.NodeView;
import freemind.modes.MindMapNode;
import freemind.modes.mindmapmode.MindMapNodeModel;
import freemind.modes.mindmapmode.MindMapMapModel;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.util.ListIterator;
import javax.swing.JOptionPane;


public class NodeDropListener implements java.awt.dnd.DropTargetListener
{

    private final freemind.controller.Controller c;

    public NodeDropListener( freemind.controller.Controller controller )
    {
        c = controller;
    }

    private boolean isDragAcceptable( java.awt.dnd.DropTargetDragEvent ev )
    {
        if (ev.isDataFlavorSupported( DataFlavor.stringFlavor )) {
            return true;
        }
        if (ev.isDataFlavorSupported( MindMapNodesSelection.fileListFlavor )) {
            return true;
        }
        return false;
    }

    private boolean isDropAcceptable( java.awt.dnd.DropTargetDropEvent event )
    {
        freemind.modes.MindMapNode node = ((freemind.view.mindmapview.NodeView) event.getDropTargetContext().getComponent()).getModel();
        freemind.modes.MindMapNode selected = c.getView().getSelected().getModel();
        return node != selected && !node.isDescendantOf( selected );
    }

    public void drop( java.awt.dnd.DropTargetDropEvent dtde )
    {
        try {
            int dropAction = dtde.getDropAction();
            java.awt.datatransfer.Transferable t = dtde.getTransferable();
            freemind.view.mindmapview.NodeView targetNodeView = (freemind.view.mindmapview.NodeView) dtde.getDropTargetContext().getComponent();
            freemind.modes.MindMapNode targetNode = targetNodeView.getModel();
            freemind.modes.mindmapmode.MindMapNodeModel targetNodeModel = (freemind.modes.mindmapmode.MindMapNodeModel) targetNode;
            if (dtde.isLocalTransfer() && t.isDataFlavorSupported( MindMapNodesSelection.dropActionFlavor )) {
                java.lang.String sourceAction = (java.lang.String) t.getTransferData( MindMapNodesSelection.dropActionFlavor );
                if (sourceAction.equals( "LINK" )) {
                    dropAction = DnDConstants.ACTION_LINK;
                }
                if (sourceAction.equals( "COPY" )) {
                    dropAction = DnDConstants.ACTION_COPY;
                }
            }
            targetNodeView.setDraggedOver( NodeView.DRAGGED_OVER_NO );
            targetNodeView.repaint();
            if (dtde.isLocalTransfer() && dropAction == DnDConstants.ACTION_MOVE && !isDropAcceptable( dtde )) {
                dtde.rejectDrop();
                return;
            }
            dtde.acceptDrop( dtde.getDropAction() );
            if (!dtde.isLocalTransfer()) {
                c.getModel().paste( t, targetNode, targetNodeView.dropAsSibling( dtde.getLocation().getX() ), targetNodeView.dropPosition( dtde.getLocation().getX() ) );
                dtde.dropComplete( true );
                return;
            }
            if (dropAction == DnDConstants.ACTION_LINK) {
                freemind.modes.mindmapmode.MindMapMapModel mindMapMapModel = (freemind.modes.mindmapmode.MindMapMapModel) c.getModel();
                int yesorno = JOptionPane.YES_OPTION;
                if (c.getView().getSelecteds().size() >= 5) {
                    yesorno = JOptionPane.showConfirmDialog( c.getFrame().getContentPane(), c.getResourceString( "lots_of_links_warning" ), Integer.toString( c.getView().getSelecteds().size() ) + " links to the same node", JOptionPane.YES_NO_OPTION );
                }
                if (yesorno == JOptionPane.YES_OPTION) {
                    for (java.util.ListIterator it = c.getView().getSelecteds().listIterator(); it.hasNext();) {
                        freemind.modes.mindmapmode.MindMapNodeModel selectedNodeModel = (freemind.modes.mindmapmode.MindMapNodeModel) ((freemind.view.mindmapview.NodeView) it.next()).getModel();
                        mindMapMapModel.addLink( selectedNodeModel, targetNodeModel );
                    }
                }
            } else {
                c.getModel().paste( dropAction == DnDConstants.ACTION_MOVE ? c.getModel().cut() : c.getModel().copy(), targetNode, targetNodeView.dropAsSibling( dtde.getLocation().getX() ), targetNodeView.dropPosition( dtde.getLocation().getX() ) );
            }
            c.getView().selectAsTheOnlyOneSelected( targetNodeModel.getViewer() );
        } catch ( java.lang.Exception e ) {
            System.err.println( "Drop exception:" + e );
            e.printStackTrace();
            dtde.dropComplete( false );
            return;
        }
        dtde.dropComplete( true );
    }

    public void dragEnter( java.awt.dnd.DropTargetDragEvent dtde )
    {
        if (isDragAcceptable( dtde )) {
            dtde.acceptDrag( DnDConstants.ACTION_MOVE );
        } else {
            dtde.rejectDrag();
        }
    }

    public void dragOver( java.awt.dnd.DropTargetDragEvent e )
    {
        freemind.view.mindmapview.NodeView draggedNode = (freemind.view.mindmapview.NodeView) e.getDropTargetContext().getComponent();
        int oldDraggedOver = draggedNode.getX();
        draggedNode.setDraggedOver( e.getLocation() );
        int newDraggedOver = draggedNode.getDraggedOver();
        boolean repaint = newDraggedOver != oldDraggedOver;
        if (repaint) {
            draggedNode.repaint();
        }
    }

    public void dragExit( java.awt.dnd.DropTargetEvent e )
    {
        freemind.view.mindmapview.NodeView draggedNode = (freemind.view.mindmapview.NodeView) e.getDropTargetContext().getComponent();
        draggedNode.setDraggedOver( NodeView.DRAGGED_OVER_NO );
        draggedNode.repaint();
    }

    public void dragScroll( java.awt.dnd.DropTargetDragEvent e )
    {
    }

    public void dropActionChanged( java.awt.dnd.DropTargetDragEvent e )
    {
    }

}
