// This is mutant program.
// Author : ysma

package freemind.view.mindmapview;


import freemind.main.FreeMindMain;
import java.awt.LayoutManager;
import java.awt.Container;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Point;
import java.util.LinkedList;
import java.util.ListIterator;
import java.lang.Math;
import javax.swing.JLabel;


public class MindMapLayout implements java.awt.LayoutManager
{

    private final int BORDER = 30;

    private final int HGAP_BASE = 20;

    private final int VGAP = 3;

    private freemind.view.mindmapview.MapView map;

    private int ySize;

    private int totalXSize;

    public MindMapLayout( freemind.view.mindmapview.MapView map )
    {
        this.map = map;
        ySize = Integer.parseInt( getFrame().getProperty( "mapysize" ) );
        totalXSize = Integer.parseInt( getFrame().getProperty( "mapxsize" ) );
    }

    public void addLayoutComponent( java.lang.String name, java.awt.Component comp )
    {
    }

    public void removeLayoutComponent( java.awt.Component comp )
    {
    }

    public void layoutContainer( java.awt.Container parent )
    {
        layout( map.getRoot() );
    }

    public void layout()
    {
        layout( map.getRoot() );
    }

    private void layout( freemind.view.mindmapview.NodeView node )
    {
        int x = 0;
        int hgap = map.getZoomed( HGAP_BASE );
        if (node.isRoot()) {
            x = 0;
        } else {
            if (node.isLeft()) {
                x = -hgap - node.getPreferredSize().width;
            } else {
                x = node.getParentView().getPreferredSize().width + hgap;
            }
        }
        placeNode( node, x, node.relYPos );
        for (java.util.ListIterator e = node.getChildrenViews().listIterator(); e.hasNext();) {
            layout( (freemind.view.mindmapview.NodeView) e.next() );
        }
    }

    private void placeNode( freemind.view.mindmapview.NodeView node, int relativeX, int relativeY )
    {
        if (node.isRoot()) {
            node.setBounds( totalXSize / 2 - node.getPreferredSize().width / 2, ySize / 2 - node.getPreferredSize().height / 2, node.getPreferredSize().width, node.getPreferredSize().height );
        } else {
            int x = node.getParentView().getLocation().x + relativeX;
            int y = node.getParentView().getLocation().y + relativeY;
            if (x < 0 || x + node.getPreferredSize().width > map.getSize().width) {
                if (node.isLeft()) {
                    resizeMap( x );
                } else {
                    resizeMap( x + node.getPreferredSize().width );
                }
                return;
            }
            node.setBounds( x, y, node.getPreferredSize().width, node.getPreferredSize().height );
            javax.swing.JLabel label = node.getEdge().getLabel();
            java.awt.Point start = node.getParentView().getOutPoint();
            java.awt.Point end = node.getInPoint();
            if (node.getParentView().isRoot()) {
                if (node.isLeft()) {
                    start = node.getParentView().getInPoint();
                }
            }
            node.getEdge().start = start;
            node.getEdge().end = end;
            int relX = (start.x - end.x) / 2;
            int absX = start.x - relX;
            int relY = (start.y - end.y) / 2;
            int absY = --start.y - relY;
            label.setBounds( absX - label.getPreferredSize().width / 2, absY - label.getPreferredSize().height / 2, label.getPreferredSize().width, label.getPreferredSize().height );
        }
    }

    public void resizeMap( int outmostX )
    {
        int oldTotalXSize = totalXSize;
        totalXSize = BORDER * 2 + (outmostX < 0 ? totalXSize + -outmostX : outmostX);
        getMapView().setSize( totalXSize, ySize );
        getMapView().scrollBy( (totalXSize - oldTotalXSize) / 2, 0 );
        layout( map.getRoot() );
    }

    void updateTreeHeightsAndRelativeYOfDescendantsAndAncestors( freemind.view.mindmapview.NodeView node )
    {
        updateTreeHeightsAndRelativeYOfDescendants( node );
        updateTreeHeightsAndRelativeYOfAncestors( node );
    }

    void updateTreeHeightsAndRelativeYOfAncestors( freemind.view.mindmapview.NodeView node )
    {
        if (node.isRoot()) {
            updateRelativeYOfChildren( node );
        } else {
            updateTreeHeightFromChildren( node );
            updateRelativeYOfChildren( node );
            updateTreeHeightsAndRelativeYOfAncestors( node.getParentView() );
        }
    }

    void updateTreeHeightsAndRelativeYOfWholeMap()
    {
        updateTreeHeightsAndRelativeYOfDescendants( getRoot() );
    }

    void updateTreeHeightsAndRelativeYOfDescendants( freemind.view.mindmapview.NodeView node )
    {
        for (java.util.ListIterator e = node.getChildrenViews().listIterator(); e.hasNext();) {
            updateTreeHeightsAndRelativeYOfDescendants( (freemind.view.mindmapview.NodeView) e.next() );
        }
        updateTreeHeightFromChildren( node );
        updateRelativeYOfChildren( node );
    }

    private void updateRelativeYOfChildren( freemind.view.mindmapview.NodeView node )
    {
        if (node.isRoot()) {
            int pointer = -(sumOfAlreadyComputedTreeHeights( getRoot().getLeft() ) / 2);
            for (java.util.ListIterator e = getRoot().getLeft().listIterator(); e.hasNext();) {
                freemind.view.mindmapview.NodeView child = (freemind.view.mindmapview.NodeView) e.next();
                pointer += child.getTreeHeight() / 2;
                child.relYPos = pointer - 2;
                pointer += child.getTreeHeight() / 2;
            }
            pointer = -(sumOfAlreadyComputedTreeHeights( getRoot().getRight() ) / 2);
            for (java.util.ListIterator e = getRoot().getRight().listIterator(); e.hasNext();) {
                freemind.view.mindmapview.NodeView child = (freemind.view.mindmapview.NodeView) e.next();
                pointer += child.getTreeHeight() / 2;
                child.relYPos = pointer - 2;
                pointer += child.getTreeHeight() / 2;
            }
        } else {
            int pointer = (node.getPreferredSize().height - node.getTreeHeight()) / 2;
            if (node.getModel().getCloud() != null) {
                pointer = (int) (pointer + 15 * getMapView().getZoom());
            }
            java.util.ListIterator it = node.getChildrenViews().listIterator();
            while (it.hasNext()) {
                freemind.view.mindmapview.NodeView child = (freemind.view.mindmapview.NodeView) it.next();
                child.relYPos = pointer + (child.getTreeHeight() - child.getPreferredSize().height) / 2 - 2;
                pointer += child.getTreeHeight();
            }
        }
    }

    private int sumOfAlreadyComputedTreeHeights( java.util.LinkedList v )
    {
        if (v == null || v.size() == 0) {
            return 0;
        }
        int height = 0;
        for (java.util.ListIterator e = v.listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView node = (freemind.view.mindmapview.NodeView) e.next();
            if (node != null) {
                height += node.getTreeHeight();
            }
        }
        return height;
    }

    protected void updateTreeHeightFromChildren( freemind.view.mindmapview.NodeView node )
    {
        int iHeight = Math.max( sumOfAlreadyComputedTreeHeights( node.getChildrenViews() ), node.getPreferredSize().height + VGAP );
        if (node.getModel().getCloud() != null) {
            iHeight = (int) (iHeight + 30 * getMapView().getZoom());
        }
        node.setTreeHeight( iHeight );
    }

    private freemind.view.mindmapview.RootNodeView getRoot()
    {
        return (freemind.view.mindmapview.RootNodeView) map.getRoot();
    }

    private freemind.view.mindmapview.MapView getMapView()
    {
        return map;
    }

    private freemind.main.FreeMindMain getFrame()
    {
        return map.getController().getFrame();
    }

    public java.awt.Dimension minimumLayoutSize( java.awt.Container parent )
    {
        return new java.awt.Dimension( 200, 200 );
    }

    public java.awt.Dimension preferredLayoutSize( java.awt.Container parent )
    {
        return new java.awt.Dimension( totalXSize, ySize );
    }

}
