// This is mutant program.
// Author : ysma

package freemind.modes.mindmapmode;


import freemind.main.FreeMindMain;
import freemind.controller.MindMapNodesSelection;
import freemind.main.XMLParseException;
import freemind.main.Tools;
import freemind.modes.MapAdapter;
import freemind.modes.MindMapNode;
import freemind.modes.MindIcon;
import freemind.modes.MindMapLink;
import freemind.modes.mindmapmode.MindMapCloudModel;
import freemind.modes.mindmapmode.MindMapArrowLinkModel;
import java.awt.Color;
import java.awt.Font;
import java.awt.datatransfer.*;
import java.io.*;
import java.util.*;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.util.TimerTask;
import java.util.Timer;
import java.lang.UnsatisfiedLinkError;
import java.lang.NoClassDefFoundError;
import java.net.URL;
import java.net.MalformedURLException;
import javax.swing.JOptionPane;
import java.nio.channels.FileLock;
import freemind.modes.LinkRegistryAdapter;
import freemind.modes.MindMapLinkRegistry;


public class MindMapMapModel extends freemind.modes.MapAdapter
{

    freemind.modes.mindmapmode.MindMapMapModel.LockManager lockManager;

    private freemind.modes.LinkRegistryAdapter linkRegistry;

    private java.util.Timer timerForAutomaticSaving;

    public MindMapMapModel( freemind.main.FreeMindMain frame )
    {
        this( new freemind.modes.mindmapmode.MindMapNodeModel( frame.getResources().getString( "new_mindmap" ), frame ), frame );
    }

    public MindMapMapModel( freemind.modes.mindmapmode.MindMapNodeModel root, freemind.main.FreeMindMain frame )
    {
        super( frame );
        lockManager = frame.getProperty( "experimental_file_locking_on" ).equals( "true" ) ? new freemind.modes.mindmapmode.MindMapMapModel.LockManager() : new freemind.modes.mindmapmode.MindMapMapModel.DummyLockManager();
        linkRegistry = new freemind.modes.LinkRegistryAdapter();
        setRoot( root );
        readOnly = false;
        timerForAutomaticSaving = new java.util.Timer();
        int delay = Integer.parseInt( getFrame().getProperty( "time_for_automatic_save" ) );
        int numberOfTempFiles = Integer.parseInt( getFrame().getProperty( "number_of_different_files_for_automatic_save" ) );
        boolean filesShouldBeDeletedAfterShutdown = Tools.safeEquals( getFrame().getProperty( "delete_automatic_saves_at_exit" ), "true" );
        java.lang.String path = getFrame().getProperty( "path_to_automatic_saves" );
        if (Tools.safeEquals( path, "default" )) {
            path = null;
        }
        if (Tools.safeEquals( path, "freemind_home" )) {
            path = getFrame().getFreemindDirectory();
        }
        java.io.File dirToStore = null;
        if (path != null) {
            dirToStore = new java.io.File( path );
            if (!dirToStore.isDirectory()) {
                dirToStore = null;
                System.err.println( "Temporary directory " + path + " not found. Disabling automatic store." );
                delay = Integer.MAX_VALUE;
            }
        }
        timerForAutomaticSaving.schedule( new freemind.modes.mindmapmode.MindMapMapModel.doAutomaticSave( this, numberOfTempFiles, filesShouldBeDeletedAfterShutdown, dirToStore ), delay, delay );
    }

    public freemind.modes.MindMapLinkRegistry getLinkRegistry()
    {
        return linkRegistry;
    }

    public java.lang.String getRestoreable()
    {
        return getFile() == null ? null : "MindMap:" + getFile().getAbsolutePath();
    }

    public void setNodeColor( freemind.modes.mindmapmode.MindMapNodeModel node, java.awt.Color color )
    {
        node.setColor( color );
        nodeChanged( node );
    }

    public void blendNodeColor( freemind.modes.mindmapmode.MindMapNodeModel node )
    {
        java.awt.Color mapColor = getBackgroundColor();
        java.awt.Color nodeColor = node.getColor();
        if (nodeColor == null) {
            nodeColor = Tools.xmlToColor( getFrame().getProperty( "standardnodecolor" ) );
        }
        node.setColor( new java.awt.Color( (3 * mapColor.getRed() + nodeColor.getRed()) / 4, (3 * mapColor.getGreen() + nodeColor.getGreen()) / 4, (3 * mapColor.getBlue() + nodeColor.getBlue()) / 4 ) );
        nodeChanged( node );
    }

    public void setNodeFont( freemind.modes.mindmapmode.MindMapNodeModel node, java.awt.Font font )
    {
        node.setFont( font );
        nodeChanged( node );
    }

    public void setEdgeColor( freemind.modes.mindmapmode.MindMapNodeModel node, java.awt.Color color )
    {
        ((freemind.modes.mindmapmode.MindMapEdgeModel) node.getEdge()).setColor( color );
        nodeChanged( node );
    }

    public void setEdgeWidth( freemind.modes.mindmapmode.MindMapNodeModel node, int width )
    {
        ((freemind.modes.mindmapmode.MindMapEdgeModel) node.getEdge()).setWidth( width );
        nodeChanged( node );
    }

    public void setNodeStyle( freemind.modes.mindmapmode.MindMapNodeModel node, java.lang.String style )
    {
        node.setStyle( style );
        nodeStructureChanged( node );
    }

    public void setEdgeStyle( freemind.modes.mindmapmode.MindMapNodeModel node, java.lang.String style )
    {
        freemind.modes.mindmapmode.MindMapEdgeModel edge = (freemind.modes.mindmapmode.MindMapEdgeModel) node.getEdge();
        edge.setStyle( style );
        nodeStructureChanged( node );
    }

    public void setBold( freemind.modes.mindmapmode.MindMapNodeModel node )
    {
        node.setBold( node.isBold() );
        nodeChanged( node );
    }

    public void setCloud( freemind.modes.mindmapmode.MindMapNodeModel node )
    {
        if (node.getCloud() == null) {
            node.setCloud( new freemind.modes.mindmapmode.MindMapCloudModel( node, getFrame() ) );
        } else {
            node.setCloud( null );
        }
        nodeChanged( node );
    }

    public void setCloudColor( freemind.modes.mindmapmode.MindMapNodeModel node, java.awt.Color color )
    {
        if (node.getCloud() == null) {
            setCloud( node );
        }
        ((freemind.modes.mindmapmode.MindMapCloudModel) node.getCloud()).setColor( color );
        nodeChanged( node );
    }

    public void setCloudWidth( freemind.modes.mindmapmode.MindMapNodeModel node, int width )
    {
        if (node.getCloud() == null) {
            setCloud( node );
        }
        ((freemind.modes.mindmapmode.MindMapCloudModel) node.getCloud()).setWidth( width );
        nodeChanged( node );
    }

    public void setCloudStyle( freemind.modes.mindmapmode.MindMapNodeModel node, java.lang.String style )
    {
        if (node.getCloud() == null) {
            setCloud( node );
        }
        freemind.modes.mindmapmode.MindMapCloudModel cloud = (freemind.modes.mindmapmode.MindMapCloudModel) node.getCloud();
        cloud.setStyle( style );
        nodeStructureChanged( node );
    }

    public void addIcon( freemind.modes.mindmapmode.MindMapNodeModel node, freemind.modes.MindIcon icon )
    {
        node.addIcon( icon );
        nodeChanged( node );
    }

    public int removeLastIcon( freemind.modes.mindmapmode.MindMapNodeModel node )
    {
        int retval = node.removeLastIcon();
        nodeChanged( node );
        return retval;
    }

    public void addLink( freemind.modes.mindmapmode.MindMapNodeModel source, freemind.modes.mindmapmode.MindMapNodeModel target )
    {
        if (getLinkRegistry().getLabel( target ) == null) {
            getLinkRegistry().registerLinkTarget( target );
        }
        freemind.modes.mindmapmode.MindMapArrowLinkModel linkModel = new freemind.modes.mindmapmode.MindMapArrowLinkModel( source, target, getFrame() );
        linkModel.setDestinationLabel( getLinkRegistry().getLabel( target ) );
        getLinkRegistry().registerLink( linkModel );
        nodeChanged( target );
        nodeChanged( source );
    }

    public void removeReference( freemind.modes.MindMapNode source, freemind.modes.mindmapmode.MindMapArrowLinkModel arrowLink )
    {
        getLinkRegistry().deregisterLink( arrowLink );
        nodeChanged( source );
        nodeChanged( arrowLink.getTarget() );
    }

    public void changeArrowsOfArrowLink( freemind.modes.MindMapNode source, freemind.modes.mindmapmode.MindMapArrowLinkModel arrowLink, boolean hasStartArrow, boolean hasEndArrow )
    {
        arrowLink.setStartArrow( hasStartArrow ? "Default" : "None" );
        arrowLink.setEndArrow( hasEndArrow ? "Default" : "None" );
        nodeChanged( source );
    }

    public void setArrowLinkColor( freemind.modes.MindMapNode source, freemind.modes.mindmapmode.MindMapArrowLinkModel arrowLink, java.awt.Color color )
    {
        arrowLink.setColor( color );
        nodeChanged( source );
    }

    public void setItalic( freemind.modes.mindmapmode.MindMapNodeModel node )
    {
        node.setItalic( !node.isItalic() );
        nodeChanged( node );
    }

    public void setUnderlined( freemind.modes.mindmapmode.MindMapNodeModel node )
    {
        node.setUnderlined( !node.isUnderlined() );
        nodeChanged( node );
    }

    public void setNormalFont( freemind.modes.mindmapmode.MindMapNodeModel node )
    {
        node.setItalic( false );
        node.setBold( false );
        node.setUnderlined( false );
        nodeChanged( node );
    }

    public void setFontFamily( freemind.modes.mindmapmode.MindMapNodeModel node, java.lang.String fontFamily )
    {
        node.estabilishOwnFont();
        node.setFont( getFrame().getController().getFontThroughMap( new java.awt.Font( fontFamily, node.getFont().getStyle(), node.getFont().getSize() ) ) );
        nodeChanged( node );
    }

    public void setFontSize( freemind.modes.mindmapmode.MindMapNodeModel node, int fontSize )
    {
        node.estabilishOwnFont();
        node.setFont( node.getFont().deriveFont( (float) fontSize ) );
        nodeChanged( node );
    }

    public void increaseFontSize( freemind.modes.mindmapmode.MindMapNodeModel node, int increment )
    {
        node.estabilishOwnFont();
        node.setFontSize( node.getFont().getSize() + increment );
        nodeChanged( node );
    }

    public java.lang.String toString()
    {
        return getFile() == null ? null : getFile().getName();
    }

    public boolean saveHTML( freemind.modes.mindmapmode.MindMapNodeModel rootNodeOfBranch, java.io.File file )
    {
        try {
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( new java.io.OutputStreamWriter( new java.io.FileOutputStream( file ) ) );
            java.lang.String el = System.getProperty( "line.separator" );
            fileout.write( "<html>" + el + "<head>" + el + "<title>" + rootNodeOfBranch.saveHTML_escapeUnicodeAndSpecialCharacters( rootNodeOfBranch.toString() ) + "</title>" + el + "<style type=\"text/css\">" + el + "    span.foldopened { color: white; font-size: xx-small;" + el + "    border-width: 1; font-family: monospace; padding: 0em 0.25em 0em 0.25em; background: #e0e0e0;" + el + "    VISIBILITY: visible;" + el + "    cursor:pointer; }" + el + "" + el + "" + el + "    span.foldclosed { color: #666666; font-size: xx-small;" + el + "    border-width: 1; font-family: monospace; padding: 0em 0.25em 0em 0.25em; background: #e0e0e0;" + el + "    VISIBILITY: hidden;" + el + "    cursor:pointer; }" + el + "" + el + "    span.foldspecial { color: #666666; font-size: xx-small; border-style: none solid solid none;" + el + "    border-color: #CCCCCC; border-width: 1; font-family: sans-serif; padding: 0em 0.1em 0em 0.1em; background: #e0e0e0;" + el + "    cursor:pointer; }" + el + "" + el + "    li { list-style: none; }" + el + "" + el + "    span.l { color: red; font-weight: bold; }" + el + "" + el + "    a:link {text-decoration: none; color: black; }" + el + "    a:visited {text-decoration: none; color: black; }" + el + "    a:active {text-decoration: none; color: black; }" + el + "    a:hover {text-decoration: none; color: black; background: #eeeee0; }" + el + "" + el + "</style>" + el + "<!-- ^ Position is not set to relative / absolute here because of Mozilla -->" + el + "</head>" + el + "<body>" + el );
            java.lang.String htmlExportFoldingOption = getFrame().getProperty( "html_export_folding" );
            boolean writeFoldingCode = htmlExportFoldingOption.equals( "html_export_fold_currently_folded" ) && rootNodeOfBranch.hasFoldedStrictDescendant() || htmlExportFoldingOption.equals( "html_export_fold_all" );
            if (writeFoldingCode) {
                fileout.write( "" + el + "<script language=\"JavaScript\">" + el + "   // Here we implement folding. It works fine with MSIE5.5, MSIE6.0 and" + el + "   // Mozilla 0.9.6." + el + "" + el + "   if (document.layers) {" + el + "      //Netscape 4 specific code" + el + "      pre = 'document.';" + el + "      post = ''; }" + el + "   if (document.getElementById) {" + el + "      //Netscape 6 specific code" + el + "      pre = 'document.getElementById(\"';" + el + "      post = '\").style'; }" + el + "   if (document.all) {" + el + "      //IE4+ specific code" + el + "      pre = 'document.all.';" + el + "      post = '.style'; }" + el + "" + el + "function layer_exists(layer) {" + el + "   try {" + el + "      eval(pre + layer + post);" + el + "      return true; }" + el + "   catch (error) {" + el + "      return false; }}" + el + "" + el + "function show_layer(layer) {" + el + "   eval(pre + layer + post).position = 'relative'; " + el + "   eval(pre + layer + post).visibility = 'visible'; }" + el + "" + el + "function hide_layer(layer) {" + el + "   eval(pre + layer + post).visibility = 'hidden';" + el + "   eval(pre + layer + post).position = 'absolute'; }" + el + "" + el + "function hide_folder(folder) {" + el + "    hide_folding_layer(folder)" + el + "    show_layer('show'+folder);" + el + "" + el + "    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "}" + el + "" + el + "function show_folder(folder) {" + el + "    // Precondition: all subfolders are folded" + el + "" + el + "    show_layer('hide'+folder);" + el + "    hide_layer('show'+folder);" + el + "    show_layer('fold'+folder);" + el + "" + el + "    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "" + el + "    var i;" + el + "    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       show_layer('show'+folder+'_'+i); }" + el + "}" + el + "" + "function show_folder_completely(folder) {" + el + "    // Precondition: all subfolders are folded" + el + "" + el + "    show_layer('hide'+folder);" + el + "    hide_layer('show'+folder);" + el + "    show_layer('fold'+folder);" + el + "" + el + "    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "" + el + "    var i;" + el + "    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       show_folder_completely(folder+'_'+i); }" + el + "}" + el + "" + el + "" + el + "" + el + "function hide_folding_layer(folder) {" + el + "   var i;" + el + "   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       hide_folding_layer(folder+'_'+i); }" + el + "" + el + "   hide_layer('hide'+folder);" + el + "   hide_layer('show'+folder);" + el + "   hide_layer('fold'+folder);" + el + "" + el + "   scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "}" + el + "" + el + "function fold_document() {" + el + "   var i;" + el + "   var folder = '1';" + el + "   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       hide_folder(folder+'_'+i); }" + el + "}" + el + "" + el + "function unfold_document() {" + el + "   var i;" + el + "   var folder = '1';" + el + "   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       show_folder_completely(folder+'_'+i); }" + el + "}" + el + "" + el + "</script>" + el );
                fileout.write( "<SPAN class=foldspecial onclick=\"fold_document()\">All +</SPAN>" + el );
                fileout.write( "<SPAN class=foldspecial onclick=\"unfold_document()\">All -</SPAN>" + el );
            }
            rootNodeOfBranch.saveHTML( fileout, "1", 0, true, true, 1 );
            if (writeFoldingCode) {
                fileout.write( "<SCRIPT language=JavaScript>" + el );
                fileout.write( "fold_document();" + el );
                fileout.write( "</SCRIPT>" + el );
            }
            fileout.write( "</body>" + el );
            fileout.write( "</html>" + el );
            fileout.close();
            return true;
        } catch ( java.lang.Exception e ) {
            System.err.println( "Error in MindMapMapModel.saveHTML(): " );
            e.printStackTrace();
            return false;
        }
    }

    public java.lang.String getAsPlainText( java.util.List mindMapNodes )
    {
        try {
            java.io.StringWriter stringWriter = new java.io.StringWriter();
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( stringWriter );
            for (java.util.ListIterator it = mindMapNodes.listIterator(); it.hasNext();) {
                ((freemind.modes.mindmapmode.MindMapNodeModel) it.next()).saveTXT( fileout, 0 );
            }
            fileout.close();
            return stringWriter.toString();
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
            return null;
        }
    }

    public boolean saveTXT( freemind.modes.mindmapmode.MindMapNodeModel rootNodeOfBranch, java.io.File file )
    {
        try {
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( new java.io.OutputStreamWriter( new java.io.FileOutputStream( file ) ) );
            rootNodeOfBranch.saveTXT( fileout, 0 );
            fileout.close();
            return true;
        } catch ( java.lang.Exception e ) {
            System.err.println( "Error in MindMapMapModel.saveTXT(): " );
            e.printStackTrace();
            return false;
        }
    }

    public java.lang.String getAsRTF( java.util.List mindMapNodes )
    {
        try {
            java.io.StringWriter stringWriter = new java.io.StringWriter();
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( stringWriter );
            saveRTF( mindMapNodes, fileout );
            fileout.close();
            return stringWriter.toString();
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
            return null;
        }
    }

    public boolean saveRTF( java.util.List mindMapNodes, java.io.BufferedWriter fileout )
    {
        try {
            java.util.HashSet colors = new java.util.HashSet();
            for (java.util.ListIterator it = mindMapNodes.listIterator(); it.hasNext();) {
                ((freemind.modes.mindmapmode.MindMapNodeModel) it.next()).collectColors( colors );
            }
            java.lang.String colorTableString = "{\\colortbl;\\red0\\green0\\blue255;";
            java.util.HashMap colorTable = new java.util.HashMap();
            int colorPosition = 2;
            for (java.util.Iterator it = colors.iterator(); it.hasNext(); ++colorPosition) {
                java.awt.Color color = (java.awt.Color) it.next();
                colorTableString += "\\red" + color.getRed() + "\\green" + color.getGreen() + "\\blue" + color.getBlue() + ";";
                colorTable.put( color, new java.lang.Integer( colorPosition ) );
            }
            colorTableString += "}";
            fileout.write( "{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang1033{\\fonttbl{\\f0\\fswiss\\fcharset0 Arial;}" + colorTableString + "}" + "\\viewkind4\\uc1\\pard\\f0\\fs20{}" );
            for (java.util.ListIterator it = mindMapNodes.listIterator(); it.hasNext();) {
                ((freemind.modes.mindmapmode.MindMapNodeModel) it.next()).saveRTF( fileout, 0, colorTable );
            }
            fileout.write( "}" );
            return true;
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
            return false;
        }
    }

    public boolean save( java.io.File file )
    {
        return saveInternal( file, false );
    }

    private boolean saveInternal( java.io.File file, boolean isInternal )
    {
        if (!isInternal && readOnly) {
            System.err.println( "Attempt to save read-only map." );
            return false;
        }
        try {
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( new java.io.OutputStreamWriter( new java.io.FileOutputStream( file ) ) );
            fileout.write( "<map version=\"" + getFrame().getFreemindVersion() + "\">\n" );
            ((freemind.modes.mindmapmode.MindMapNodeModel) getRoot()).save( fileout, this );
            fileout.write( "</map>\n" );
            fileout.close();
            if (!isInternal) {
                setFile( file );
                setSaved( true );
            }
            return true;
        } catch ( java.io.FileNotFoundException e ) {
            java.lang.String message = Tools.expandPlaceholders( getText( "save_failed" ), file.getName() );
            if (!isInternal) {
                getFrame().getController().errorMessage( message );
            } else {
                getFrame().out( message );
            }
            return false;
        } catch ( java.lang.Exception e ) {
            System.err.println( "Error in MindMapMapModel.save(): " );
            e.printStackTrace();
            return false;
        }
    }

    public java.lang.String tryToLock( java.io.File file )
        throws java.lang.Exception
    {
        java.lang.String lockingUser = lockManager.tryToLock( file );
        java.lang.String lockingUserOfOldLock = lockManager.popLockingUserOfOldLock();
        if (lockingUserOfOldLock != null) {
            getFrame().getController().informationMessage( Tools.expandPlaceholders( getText( "locking_old_lock_removed" ), file.getName(), lockingUserOfOldLock ) );
        }
        if (lockingUser == null) {
            readOnly = false;
        }
        return lockingUser;
    }

    public void load( java.io.File file )
        throws java.io.FileNotFoundException, java.io.IOException, freemind.main.XMLParseException
    {
        if (!file.exists()) {
            throw new java.io.FileNotFoundException( Tools.expandPlaceholders( getText( "file_not_found" ), file.getPath() ) );
        }
        if (!file.canWrite()) {
            readOnly = true;
        } else {
            try {
                java.lang.String lockingUser = tryToLock( file );
                if (lockingUser != null) {
                    getFrame().getController().informationMessage( Tools.expandPlaceholders( getText( "map_locked_by_open" ), file.getName(), lockingUser ) );
                    readOnly = true;
                } else {
                    readOnly = false;
                }
            } catch ( java.lang.Exception e ) {
                e.printStackTrace();
                getFrame().getController().informationMessage( Tools.expandPlaceholders( getText( "locking_failed_by_open" ), file.getName() ) );
                readOnly = true;
            }
        }
        freemind.modes.mindmapmode.MindMapNodeModel root = loadTree( file );
        if (root != null) {
            setRoot( root );
        }
        setFile( file );
        setSaved( true );
    }

    public void destroy()
    {
        lockManager.releaseLock();
        lockManager.releaseTimer();
        timerForAutomaticSaving.cancel();
    }

    freemind.modes.mindmapmode.MindMapNodeModel loadTree( java.io.File file )
        throws freemind.main.XMLParseException, java.io.IOException
    {
        freemind.modes.mindmapmode.MindMapXMLElement mapElement = new freemind.modes.mindmapmode.MindMapXMLElement( getFrame() );
        try {
            mapElement.parseFromReader( new java.io.BufferedReader( new java.io.FileReader( file ) ) );
        } catch ( java.lang.Exception ex ) {
            System.err.println( "Error while parsing file:" + ex );
            ex.printStackTrace();
            return null;
        }
        mapElement.processUnfinishedLinks( getLinkRegistry() );
        return (freemind.modes.mindmapmode.MindMapNodeModel) mapElement.getMapChild();
    }

    public java.awt.datatransfer.Transferable copy( freemind.modes.MindMapNode node )
    {
        java.io.StringWriter stringWriter = new java.io.StringWriter();
        try {
            ((freemind.modes.mindmapmode.MindMapNodeModel) node).save( stringWriter, this );
        } catch ( java.io.IOException e ) {
        }
        return new java.awt.datatransfer.StringSelection( stringWriter.toString() );
    }

    public void splitNode( freemind.modes.MindMapNode node, int caretPosition, java.lang.String newText )
    {
        java.lang.String currentText = newText != null ? newText : node.toString();
        java.lang.String newContent = currentText.substring( caretPosition, currentText.length() );
        freemind.modes.mindmapmode.MindMapNodeModel upperNode = new freemind.modes.mindmapmode.MindMapNodeModel( currentText.substring( 0, caretPosition ), getFrame() );
        upperNode.setColor( node.getColor() );
        upperNode.setFont( node.getFont() );
        node.setUserObject( newContent );
        freemind.modes.MindMapNode parent = node.getParentNode();
        insertNodeInto( upperNode, parent, parent.getChildPosition( node ) );
        nodeStructureChanged( parent );
    }

    public void joinNodes()
    {
        freemind.modes.MindMapNode selectedNode = getFrame().getView().getSelected().getModel();
        java.util.ArrayList selectedNodes = getFrame().getView().getSelectedNodesSortedByY();
        java.lang.String newContent = "";
        boolean firstLoop = true;
        for (java.util.Iterator it = selectedNodes.iterator(); it.hasNext();) {
            freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) it.next();
            if (node.hasChildren()) {
                JOptionPane.showMessageDialog( node.getViewer(), getText( "cannot_join_nodes_with_children" ), "FreeMind", JOptionPane.WARNING_MESSAGE );
                return;
            }
        }
        for (java.util.Iterator it = selectedNodes.iterator(); it.hasNext();) {
            if (firstLoop) {
                firstLoop = false;
            } else {
                newContent += " ";
            }
            freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) it.next();
            newContent += node.toString();
            if (node != selectedNode) {
                removeNodeFromParent( node );
            }
        }
        getFrame().getView().selectAsTheOnlyOneSelected( selectedNode.getViewer() );
        changeNode( selectedNode, newContent );
    }

    public boolean importExplorerFavorites( java.io.File folder, freemind.modes.MindMapNode target, boolean redisplay )
    {
        boolean favoritesFound = false;
        if (folder.isDirectory()) {
            java.io.File[] list = folder.listFiles();
            for (int i = 0; i < list.length; i++) {
                if (list[i].isDirectory()) {
                    freemind.modes.mindmapmode.MindMapNodeModel node = new freemind.modes.mindmapmode.MindMapNodeModel( list[i].getName(), getFrame() );
                    insertNodeIntoNoEvent( node, target );
                    boolean favoritesFoundInSubfolder = importExplorerFavorites( list[i], node, false );
                    if (favoritesFoundInSubfolder) {
                        favoritesFound = true;
                    } else {
                        removeNodeFromParent( node, false );
                    }
                }
            }
            for (int i = 0; i < list.length; i++) {
                if (!list[i].isDirectory() && Tools.getExtension( list[i] ).equals( "url" )) {
                    favoritesFound = true;
                    try {
                        freemind.modes.mindmapmode.MindMapNodeModel node = new freemind.modes.mindmapmode.MindMapNodeModel( Tools.removeExtension( list[i].getName() ), getFrame() );
                        java.io.BufferedReader in = new java.io.BufferedReader( new java.io.FileReader( list[i] ) );
                        while (in.ready()) {
                            java.lang.String line = in.readLine();
                            if (line.startsWith( "URL=" )) {
                                node.setLink( line.substring( 4 ) );
                                break;
                            }
                        }
                        insertNodeIntoNoEvent( node, target );
                    } catch ( java.lang.Exception e ) {
                        e.printStackTrace();
                    }
                }
            }
        }
        if (redisplay) {
            nodeStructureChanged( target );
        }
        return favoritesFound;
    }

    public void importFolderStructure( java.io.File folder, freemind.modes.MindMapNode target, boolean redisplay )
    {
        if (folder.isDirectory()) {
            java.io.File[] list = folder.listFiles();
            for (int i = 0; i < list.length; i++) {
                if (list[i].isDirectory()) {
                    freemind.modes.mindmapmode.MindMapNodeModel node = new freemind.modes.mindmapmode.MindMapNodeModel( list[i].getName(), getFrame() );
                    try {
                        node.setLink( list[i].toURL().toString() );
                    } catch ( java.net.MalformedURLException e ) {
                        e.printStackTrace();
                    }
                    insertNodeIntoNoEvent( node, target );
                    importFolderStructure( list[i], node, false );
                }
            }
            for (int i = 0; i < list.length; i++) {
                if (!list[i].isDirectory()) {
                    freemind.modes.mindmapmode.MindMapNodeModel node = new freemind.modes.mindmapmode.MindMapNodeModel( list[i].getName(), getFrame() );
                    try {
                        node.setLink( list[i].toURL().toString() );
                    } catch ( java.net.MalformedURLException e ) {
                        e.printStackTrace();
                    }
                    insertNodeIntoNoEvent( node, target );
                }
            }
        }
        if (redisplay) {
            nodeStructureChanged( target );
        }
    }

    private freemind.modes.mindmapmode.MindMapNodeModel pasteXMLWithoutRedisplay( java.lang.String pasted, freemind.modes.MindMapNode target )
        throws freemind.main.XMLParseException
    {
        return pasteXMLWithoutRedisplay( pasted, target, false );
    }

    private freemind.modes.mindmapmode.MindMapNodeModel pasteXMLWithoutRedisplay( java.lang.String pasted, freemind.modes.MindMapNode target, boolean asSibling )
        throws freemind.main.XMLParseException
    {
        try {
            freemind.modes.mindmapmode.MindMapXMLElement element = new freemind.modes.mindmapmode.MindMapXMLElement( getFrame() );
            element.parseFromReader( new java.io.StringReader( pasted ) );
            freemind.modes.mindmapmode.MindMapNodeModel node = (freemind.modes.mindmapmode.MindMapNodeModel) element.getUserObject();
            if (asSibling) {
                freemind.modes.MindMapNode parent = target.getParentNode();
                insertNodeInto( node, parent, parent.getChildPosition( target ) );
            } else {
                insertNodeIntoNoEvent( node, target );
            }
            element.processUnfinishedLinks( getLinkRegistry() );
            return node;
        } catch ( java.io.IOException ee ) {
            ee.printStackTrace();
            return null;
        }
    }

    static final java.util.regex.Pattern nonLinkCharacter = Pattern.compile( "[ \n()'\",;]" );

    private freemind.modes.MindMapNode pasteStringWithoutRedisplay( java.lang.String textFromClipboard, freemind.modes.MindMapNode parent, boolean asSibling )
    {
        java.util.regex.Pattern mailPattern = Pattern.compile( "([^@ <>\\*']+@[^@ <>\\*']+)" );
        java.lang.String[] textLines = textFromClipboard.split( "\n" );
        if (textLines.length > 1) {
            getFrame().setWaitingCursor( true );
        }
        freemind.modes.MindMapNode realParent = null;
        if (asSibling) {
            realParent = parent;
            parent = new freemind.modes.mindmapmode.MindMapNodeModel( getFrame() );
        }
        java.util.ArrayList parentNodes = new java.util.ArrayList();
        java.util.ArrayList parentNodesDepths = new java.util.ArrayList();
        parentNodes.add( parent );
        parentNodesDepths.add( new java.lang.Integer( -1 ) );
        java.lang.String[] linkPrefixes = { "http://", "ftp://", "https://" };
        freemind.modes.mindmapmode.MindMapNodeModel pastedNode = null;
        for (int i = 0; i < textLines.length; ++i) {
            java.lang.String text = textLines[i];
            text = text.replaceAll( "\t", "        " );
            if (text.matches( " *" )) {
                continue;
            }
            int depth = 0;
            while (depth < text.length() && text.charAt( depth ) == ' ') {
                ++depth;
            }
            java.lang.String visibleText = text.trim();
            if (visibleText.matches( "^http://(www\\.)?[^ ]*$" )) {
                visibleText = visibleText.replaceAll( "^http://(www\\.)?", "" ).replaceAll( "(/|\\.[^\\./\\?]*)$", "" ).replaceAll( "((\\.[^\\./]*\\?)|\\?)[^/]*$", " ? ..." ).replaceAll( "_|%20", " " );
                java.lang.String[] textParts = visibleText.split( "/" );
                visibleText = "";
                for (int textPartIdx = 0; textPartIdx < textParts.length; textPartIdx++) {
                    if (textPartIdx > 0) {
                        visibleText += " > ";
                    }
                    visibleText += textPartIdx == 0 ? textParts[textPartIdx] : Tools.firstLetterCapitalized( textParts[textPartIdx].replaceAll( "^~*", "" ) );
                }
            }
            freemind.modes.mindmapmode.MindMapNodeModel node = new freemind.modes.mindmapmode.MindMapNodeModel( visibleText, getFrame() );
            if (textLines.length == 1) {
                pastedNode = node;
            }
            java.util.regex.Matcher mailMatcher = mailPattern.matcher( visibleText );
            if (mailMatcher.find()) {
                node.setLink( "mailto:" + mailMatcher.group() );
            }
            for (int j = 0; j < linkPrefixes.length; j++) {
                int linkStart = text.indexOf( linkPrefixes[j] );
                if (linkStart != -1) {
                    int linkEnd = linkStart;
                    while (linkEnd < text.length() && !nonLinkCharacter.matcher( text.substring( linkEnd, linkEnd + 1 ) ).matches()) {
                        linkEnd++;
                    }
                    node.setLink( text.substring( linkStart, linkEnd ) );
                }
            }
            for (int j = parentNodes.size() - 1; j >= 0; --j) {
                if (depth > ((java.lang.Integer) parentNodesDepths.get( j )).intValue()) {
                    for (int k = j + 1; k < parentNodes.size(); ++k) {
                        parentNodes.remove( k );
                        parentNodesDepths.remove( k );
                    }
                    freemind.modes.MindMapNode target = (freemind.modes.MindMapNode) parentNodes.get( j );
                    insertNodeIntoNoEvent( node, target );
                    parentNodes.add( node );
                    parentNodesDepths.add( new java.lang.Integer( depth ) );
                    break;
                }
            }
        }
        if (asSibling) {
            for (java.util.Iterator i = parent.childrenUnfolded(); i.hasNext();) {
                insertNodeIntoNoEvent( (freemind.modes.MindMapNode) i.next(), realParent, asSibling );
            }
            nodeStructureChanged( realParent.getParentNode() );
        } else {
            nodeStructureChanged( parent );
        }
        return pastedNode;
    }

    public void paste( java.awt.datatransfer.Transferable t, freemind.modes.MindMapNode target, boolean asSibling, boolean isLeft )
    {
        if (t == null) {
            return;
        }
        try {
            if (t.isDataFlavorSupported( MindMapNodesSelection.fileListFlavor )) {
                System.err.println( "flflpas" );
                java.util.List fileList = (java.util.List) t.getTransferData( MindMapNodesSelection.fileListFlavor );
                for (java.util.ListIterator it = fileList.listIterator(); it.hasNext();) {
                    java.io.File file = (java.io.File) it.next();
                    freemind.modes.mindmapmode.MindMapNodeModel node = new freemind.modes.mindmapmode.MindMapNodeModel( file.getName(), getFrame() );
                    node.setLink( file.getAbsolutePath() );
                    insertNodeIntoNoEvent( node, target, asSibling );
                }
                nodeStructureChanged( asSibling ? target.getParent() : target );
            } else {
                if (t.isDataFlavorSupported( MindMapNodesSelection.mindMapNodesFlavor )) {
                    java.lang.String textFromClipboard = (java.lang.String) t.getTransferData( MindMapNodesSelection.mindMapNodesFlavor );
                    java.lang.String[] textLines = textFromClipboard.split( "<nodeseparator>" );
                    if (textLines.length > 1) {
                        getFrame().setWaitingCursor( true );
                    }
                    for (int i = 0; i < textLines.length; ++i) {
                        freemind.modes.mindmapmode.MindMapNodeModel newModel = pasteXMLWithoutRedisplay( textLines[i], target, asSibling );
                        newModel.setLeft( isLeft );
                    }
                } else {
                    if (t.isDataFlavorSupported( MindMapNodesSelection.htmlFlavor )) {
                        java.lang.String textFromClipboard = (java.lang.String) t.getTransferData( MindMapNodesSelection.htmlFlavor );
                        freemind.modes.MindMapNode pastedNode = pasteStringWithoutRedisplay( (java.lang.String) t.getTransferData( DataFlavor.stringFlavor ), target, asSibling );
                        textFromClipboard = textFromClipboard.replaceAll( "<!--.*?-->", "" );
                        java.lang.String[] links = textFromClipboard.split( "<[aA][^>]*[hH][rR][eE][fF]=\"" );
                        freemind.modes.mindmapmode.MindMapNodeModel linkParentNode = null;
                        java.net.URL referenceURL = null;
                        boolean baseUrlCanceled = false;
                        for (int i = 1; i < links.length; i++) {
                            java.lang.String link = links[i].substring( 0, links[i].indexOf( "\"" ) );
                            java.lang.String textWithHtml = links[i].replaceAll( "^[^>]*>", "" ).replaceAll( "</[aA]>[\\s\\S]*", "" );
                            java.lang.String text = Tools.toXMLUnescapedText( textWithHtml.replaceAll( "\\n", "" ).replaceAll( "<[^>]*>", "" ).trim() );
                            if (text.equals( "" )) {
                                text = link;
                            }
                            java.net.URL linkURL = null;
                            try {
                                linkURL = new java.net.URL( link );
                            } catch ( java.net.MalformedURLException ex ) {
                                try {
                                    if (referenceURL == null && !baseUrlCanceled) {
                                        java.lang.String referenceURLString = JOptionPane.showInputDialog( getText( "enter_base_url" ) );
                                        if (referenceURLString == null) {
                                            baseUrlCanceled = true;
                                        } else {
                                            referenceURL = new java.net.URL( referenceURLString );
                                        }
                                    }
                                    linkURL = new java.net.URL( referenceURL, link );
                                } catch ( java.net.MalformedURLException ex2 ) {
                                }
                            }
                            if (linkURL != null) {
                                if (links.length == 2 & pastedNode != null) {
                                    ((freemind.modes.mindmapmode.MindMapNodeModel) pastedNode).setLink( linkURL.toString() );
                                    break;
                                }
                                if (linkParentNode == null) {
                                    linkParentNode = new freemind.modes.mindmapmode.MindMapNodeModel( "Links", getFrame() );
                                    insertNodeInto( linkParentNode, target );
                                    linkParentNode.setBold( true );
                                }
                                freemind.modes.mindmapmode.MindMapNodeModel linkNode = new freemind.modes.mindmapmode.MindMapNodeModel( text, getFrame() );
                                linkNode.setLink( linkURL.toString() );
                                insertNodeInto( linkNode, linkParentNode );
                            }
                        }
                    } else {
                        if (t.isDataFlavorSupported( DataFlavor.stringFlavor )) {
                            java.lang.String textFromClipboard = (java.lang.String) t.getTransferData( DataFlavor.stringFlavor );
                            pasteStringWithoutRedisplay( textFromClipboard, target, asSibling );
                        }
                    }
                }
            }
            nodeStructureChanged( asSibling ? target.getParent() : target );
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
        }
        getFrame().setWaitingCursor( false );
    }

    private class LockManager extends java.util.TimerTask
    {

        java.io.File lockedSemaphoreFile = null;

        java.util.Timer lockTimer = null;

        final long lockUpdatePeriod = 4 * 60 * 1000;

        final long lockSafetyPeriod = 5 * 60 * 1000;

        java.lang.String lockingUserOfOldLock = null;

        private java.io.File getSemaphoreFile( java.io.File mapFile )
        {
            return new java.io.File( mapFile.getParent() + System.getProperty( "file.separator" ) + "$~" + mapFile.getName() + "~" );
        }

        public synchronized java.lang.String popLockingUserOfOldLock()
        {
            java.lang.String toReturn = lockingUserOfOldLock;
            lockingUserOfOldLock = null;
            return toReturn;
        }

        private void writeSemaphoreFile( java.io.File inSemaphoreFile )
                throws java.lang.Exception
        {
            java.io.FileOutputStream semaphoreOutputStream = new java.io.FileOutputStream( inSemaphoreFile );
            java.nio.channels.FileLock lock = null;
            try {
                lock = semaphoreOutputStream.getChannel().tryLock();
                if (lock == null) {
                    semaphoreOutputStream.close();
                    System.err.println( "Locking failed." );
                    throw new java.lang.Exception();
                }
            } catch ( java.lang.UnsatisfiedLinkError eUle ) {
            } catch ( java.lang.NoClassDefFoundError eDcdf ) {
            }
            semaphoreOutputStream.write( System.getProperty( "user.name" ).getBytes() );
            semaphoreOutputStream.write( '\n' );
            semaphoreOutputStream.write( String.valueOf( System.currentTimeMillis() ).getBytes() );
            semaphoreOutputStream.close();
            semaphoreOutputStream = null;
            Tools.setHidden( inSemaphoreFile, true, false );
            if (lock != null) {
                lock.release();
            }
        }

        public synchronized java.lang.String tryToLock( java.io.File file )
                throws java.lang.Exception
        {
            java.io.File semaphoreFile = getSemaphoreFile( file );
            if (semaphoreFile == lockedSemaphoreFile) {
                return null;
            }
            try {
                java.io.BufferedReader semaphoreReader = new java.io.BufferedReader( new java.io.FileReader( semaphoreFile ) );
                java.lang.String lockingUser = semaphoreReader.readLine();
                long lockTime = (new java.lang.Long( semaphoreReader.readLine() )).longValue();
                long timeDifference = System.currentTimeMillis() - lockTime;
                if (timeDifference > lockSafetyPeriod) {
                    semaphoreReader.close();
                    lockingUserOfOldLock = lockingUser;
                    semaphoreFile.delete();
                } else {
                    return lockingUser;
                }
            } catch ( java.io.FileNotFoundException e ) {
            }
            writeSemaphoreFile( semaphoreFile );
            if (lockTimer == null) {
                lockTimer = new java.util.Timer();
                lockTimer.schedule( this, lockUpdatePeriod, lockUpdatePeriod );
            }
            releaseLock();
            lockedSemaphoreFile = semaphoreFile;
            return null;
        }

        public synchronized void releaseLock()
        {
            if (lockedSemaphoreFile != null) {
                lockedSemaphoreFile.delete();
                lockedSemaphoreFile = null;
            }
        }

        public synchronized void releaseTimer()
        {
            if (lockTimer != null) {
                lockTimer.cancel();
                lockTimer = null;
            }
        }

        public synchronized void run()
        {
            if (lockedSemaphoreFile == null) {
                System.err.println( "unexpected: lockedSemaphoreFile is null upon lock update" );
                return;
            }
            try {
                Tools.setHidden( lockedSemaphoreFile, false, true );
                writeSemaphoreFile( lockedSemaphoreFile );
            } catch ( java.lang.Exception e ) {
                e.printStackTrace();
            }
        }

    }

    private class DummyLockManager extends freemind.modes.mindmapmode.MindMapMapModel.LockManager
    {

        public synchronized java.lang.String popLockingUserOfOldLock()
        {
            return null;
        }

        public synchronized java.lang.String tryToLock( java.io.File file )
                throws java.lang.Exception
        {
            return null;
        }

        public synchronized void releaseLock()
        {
        }

        public synchronized void releaseTimer()
        {
        }

        public synchronized void run()
        {
        }

    }

    private class doAutomaticSave extends java.util.TimerTask
    {

        private freemind.modes.mindmapmode.MindMapMapModel model;

        private java.util.Vector tempFileStack;

        private int numberOfFiles;

        private boolean filesShouldBeDeletedAfterShutdown;

        private java.io.File pathToStore;

        private int changeState;

        doAutomaticSave( freemind.modes.mindmapmode.MindMapMapModel model, int numberOfTempFiles, boolean filesShouldBeDeletedAfterShutdown, java.io.File pathToStore )
        {
            this.model = model;
            tempFileStack = new java.util.Vector();
            numberOfFiles = numberOfTempFiles > 0 ? numberOfTempFiles : 1;
            this.filesShouldBeDeletedAfterShutdown = filesShouldBeDeletedAfterShutdown;
            this.pathToStore = pathToStore;
            changeState = 0;
        }

        public void run()
        {
            if (model.getNumberOfChangesSinceLastSave() == changeState) {
                return;
            }
            changeState = model.getNumberOfChangesSinceLastSave();
            if (model.getNumberOfChangesSinceLastSave() == 0) {
                return;
            }
            java.io.File tempFile;
            if (tempFileStack.size() >= numberOfFiles) {
                tempFile = (java.io.File) tempFileStack.remove( 0 );
            } else {
                try {
                    tempFile = File.createTempFile( "FM_" + (model.toString() == null ? "unnamed" : model.toString()), ".mm", pathToStore );
                    if (filesShouldBeDeletedAfterShutdown) {
                        tempFile.deleteOnExit();
                    }
                } catch ( java.lang.Exception e ) {
                    System.err.println( "Error in automatic MindMapMapModel.save(): " + e.getMessage() );
                    e.printStackTrace();
                    return;
                }
            }
            try {
                model.saveInternal( tempFile, true );
                model.getFrame().out( "Map was automatically saved (using the file name " + tempFile + ") ..." );
            } catch ( java.lang.Exception e ) {
                System.err.println( "Error in automatic MindMapMapModel.save(): " + e.getMessage() );
                e.printStackTrace();
            }
            tempFileStack.add( tempFile );
        }

    }

}
