// This is mutant program.
// Author : ysma

package freemind.controller;


import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.print.PageFormat;
import java.awt.print.PrinterJob;
import java.net.URL;
import java.text.MessageFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import javax.swing.*;
import java.net.MalformedURLException;
import freemind.main.FreeMind;
import freemind.main.FreeMindMain;
import freemind.main.Tools;
import freemind.modes.MindMap;
import freemind.modes.Mode;
import freemind.modes.ModesCreator;
import freemind.modes.browsemode.BrowseController;
import freemind.view.MapModule;
import freemind.view.mindmapview.MapView;


public class Controller
{

    private freemind.controller.LastOpenedList lastOpened;

    private freemind.controller.Controller.MapModuleManager mapModuleManager;

    private freemind.controller.Controller.HistoryManager history = new freemind.controller.Controller.HistoryManager();

    private java.util.Map modes;

    private freemind.modes.Mode mode;

    private freemind.main.FreeMindMain frame;

    private javax.swing.JToolBar toolbar;

    private freemind.controller.NodeMouseMotionListener nodeMouseMotionListener;

    private freemind.controller.NodeKeyListener nodeKeyListener;

    private freemind.controller.NodeDragListener nodeDragListener;

    private freemind.controller.NodeDropListener nodeDropListener;

    private freemind.controller.MapMouseMotionListener mapMouseMotionListener;

    private freemind.controller.MapMouseWheelListener mapMouseWheelListener;

    private freemind.modes.ModesCreator modescreator = new freemind.modes.ModesCreator( this );

    private java.awt.print.PageFormat pageFormat = null;

    private java.awt.print.PrinterJob printerJob = null;

    private javax.swing.Icon bswatch = new freemind.controller.Controller.BackgroundSwatch();

    private boolean antialiasEdges = false;

    private boolean antialiasAll = false;

    private java.util.Map fontMap = new java.util.HashMap();

    boolean isPrintingAllowed = true;

    boolean menubarVisible = true;

    boolean toolbarVisible = true;

    boolean leftToolbarVisible = true;

    javax.swing.Action close;

    javax.swing.Action print;

    javax.swing.Action printDirect;

    javax.swing.Action page;

    public javax.swing.Action quit;

    javax.swing.Action background;

    javax.swing.Action optionAntialiasAction;

    javax.swing.Action optionHTMLExportFoldingAction;

    javax.swing.Action optionSelectionMechanismAction;

    javax.swing.Action about;

    javax.swing.Action faq;

    javax.swing.Action documentation;

    javax.swing.Action license;

    javax.swing.Action historyPreviousMap;

    javax.swing.Action historyNextMap;

    javax.swing.Action navigationPreviousMap;

    javax.swing.Action navigationNextMap;

    javax.swing.Action moveToRoot;

    javax.swing.Action toggleMenubar;

    javax.swing.Action toggleToolbar;

    javax.swing.Action toggleLeftToolbar;

    javax.swing.Action zoomIn;

    javax.swing.Action zoomOut;

    private static final java.lang.String[] zooms = { "25%", "40%", "60%", "75%", "100%", "125%", "150%", "200%" };

    public Controller( freemind.main.FreeMindMain frame )
    {
        checkJavaVersion();
        this.frame = frame;
        modes = modescreator.getAllModes();
        mapModuleManager = new freemind.controller.Controller.MapModuleManager( this );
        lastOpened = new freemind.controller.LastOpenedList( this, getProperty( "lastOpened" ) );
        nodeMouseMotionListener = new freemind.controller.NodeMouseMotionListener( this );
        nodeKeyListener = new freemind.controller.NodeKeyListener( this );
        nodeDragListener = new freemind.controller.NodeDragListener( this );
        nodeDropListener = new freemind.controller.NodeDropListener( this );
        mapMouseMotionListener = new freemind.controller.MapMouseMotionListener( this );
        mapMouseWheelListener = new freemind.controller.MapMouseWheelListener( this );
        close = new freemind.controller.Controller.CloseAction( this );
        print = new freemind.controller.Controller.PrintAction( this, true );
        printDirect = new freemind.controller.Controller.PrintAction( this, false );
        page = new freemind.controller.Controller.PageAction( this );
        quit = new freemind.controller.Controller.QuitAction( this );
        background = new freemind.controller.Controller.BackgroundAction( this, bswatch );
        about = new freemind.controller.Controller.AboutAction( this );
        faq = new freemind.controller.Controller.OpenFAQAction( this );
        documentation = new freemind.controller.Controller.DocumentationAction( this );
        license = new freemind.controller.Controller.LicenseAction( this );
        historyPreviousMap = new freemind.controller.Controller.HistoryPreviousMapAction( this );
        historyNextMap = new freemind.controller.Controller.HistoryNextMapAction( this );
        navigationPreviousMap = new freemind.controller.Controller.NavigationPreviousMapAction( this );
        navigationNextMap = new freemind.controller.Controller.NavigationNextMapAction( this );
        toggleMenubar = new freemind.controller.Controller.ToggleMenubarAction( this );
        toggleToolbar = new freemind.controller.Controller.ToggleToolbarAction( this );
        toggleLeftToolbar = new freemind.controller.Controller.ToggleLeftToolbarAction( this );
        optionAntialiasAction = new freemind.controller.Controller.OptionAntialiasAction( this );
        optionHTMLExportFoldingAction = new freemind.controller.Controller.OptionHTMLExportFoldingAction( this );
        optionSelectionMechanismAction = new freemind.controller.Controller.OptionSelectionMechanismAction( this );
        zoomIn = new freemind.controller.Controller.ZoomInAction( this );
        zoomOut = new freemind.controller.Controller.ZoomOutAction( this );
        moveToRoot = new freemind.controller.Controller.MoveToRootAction( this );
        toolbar = new freemind.controller.MainToolBar( this );
        getFrame().getContentPane().add( toolbar, BorderLayout.NORTH );
        setAllActions( false );
        if (!Tools.isAvailableFontFamily( getProperty( "standardfont" ) )) {
            System.out.println( "Warning: the font you have set as standard - " + getProperty( "standardfont" ) + " - is not available." );
            frame.setProperty( "standardfont", "SansSerif" );
        }
    }

    public void checkJavaVersion()
    {
        if (System.getProperty( "java.version" ).compareTo( "1.4.0" ) < 0) {
            java.lang.String message = "Warning: FreeMind requires version Java 1.4.0 or higher (your version: " + System.getProperty( "java.version" ) + ").";
            System.err.println( message );
            JOptionPane.showMessageDialog( null, message, "FreeMind", JOptionPane.WARNING_MESSAGE );
        }
    }

    public java.lang.String getProperty( java.lang.String property )
    {
        return frame.getProperty( property );
    }

    public void setProperty( java.lang.String property, java.lang.String value )
    {
        frame.setProperty( property, value );
    }

    public freemind.main.FreeMindMain getFrame()
    {
        return frame;
    }

    public java.net.URL getResource( java.lang.String resource )
    {
        return getFrame().getResource( resource );
    }

    public java.lang.String getResourceString( java.lang.String resource )
    {
        try {
            return frame.getResources().getString( resource );
        } catch ( java.lang.Exception ex ) {
            System.err.println( "Warning - resource string not found:" + resource );
            return resource;
        }
    }

    public freemind.modes.MindMap getModel()
    {
        if (getMapModule() != null) {
            return getMapModule().getModel();
        }
        return null;
    }

    public freemind.view.mindmapview.MapView getView()
    {
        if (getMapModule() != null) {
            return getMapModule().getView();
        } else {
            System.err.println( "[Freemind-Developer-Internal-Warning (do not write a bug report, please)]: Tried to get view without being able to get map module." );
        }
        return null;
    }

    java.util.Map getModes()
    {
        return modes;
    }

    public freemind.modes.Mode getMode()
    {
        return mode;
    }

    public java.lang.String[] getZooms()
    {
        return zooms;
    }

    public freemind.controller.Controller.MapModuleManager getMapModuleManager()
    {
        return mapModuleManager;
    }

    public freemind.controller.LastOpenedList getLastOpenedList()
    {
        return lastOpened;
    }

    private freemind.view.MapModule getMapModule()
    {
        return getMapModuleManager().getMapModule();
    }

    private javax.swing.JToolBar getToolBar()
    {
        return toolbar;
    }

    public java.awt.Font getFontThroughMap( java.awt.Font font )
    {
        if (!fontMap.containsKey( font.toString() )) {
            fontMap.put( font.toString(), font );
        }
        return (java.awt.Font) fontMap.get( font.toString() );
    }

    public void setAntialiasEdges( boolean antialiasEdges )
    {
        this.antialiasEdges = antialiasEdges;
    }

    public void setAntialiasAll( boolean antialiasAll )
    {
        this.antialiasAll = antialiasAll;
    }

    public boolean getAntialiasEdges()
    {
        return antialiasEdges;
    }

    public boolean getAntialiasAll()
    {
        return antialiasAll;
    }

    public java.awt.Font getDefaultFont()
    {
        int fontSize = Integer.parseInt( getFrame().getProperty( "defaultfontsize" ) );
        int fontStyle = Integer.parseInt( getFrame().getProperty( "defaultfontstyle" ) );
        java.lang.String fontFamily = getProperty( "defaultfont" );
        return getFontThroughMap( new java.awt.Font( fontFamily, fontStyle, fontSize ) );
    }

    public boolean changeToMode( java.lang.String mode )
    {
        if (getMode() != null && mode.equals( getMode().toString() )) {
            return true;
        }
        freemind.modes.Mode newmode = (freemind.modes.Mode) modes.get( mode );
        if (newmode == null) {
            errorMessage( getResourceString( "mode_na" ) + ": " + mode );
            return false;
        }
        if (getMode() != null && getMode().getModeToolBar() != null) {
            toolbar.remove( getMode().getModeToolBar() );
        }
        if (getMode() != null && getMode().getLeftToolBar() != null) {
            getFrame().getContentPane().remove( getMode().getLeftToolBar() );
        }
        if (getMapModule() != null) {
            getMapModuleManager().setMapModule( null );
            getMapModuleManager().mapModuleChanged();
        }
        this.mode = newmode;
        if (getMode().getModeToolBar() != null) {
            toolbar.add( getMode().getModeToolBar() );
            getMode().getModeToolBar().repaint();
        }
        if (getMode().getLeftToolBar() != null) {
            getFrame().getContentPane().add( getMode().getLeftToolBar(), BorderLayout.WEST );
            getMode().getLeftToolBar().repaint();
        }
        toolbar.validate();
        toolbar.repaint();
        setTitle();
        getMode().activate();
        getFrame().getFreeMindMenuBar().updateFileMenu();
        getFrame().getFreeMindMenuBar().updateEditMenu();
        if (getMapModule() == null) {
            setAllActions( false );
        }
        java.lang.Object[] messageArguments = { getMode().toString() };
        java.text.MessageFormat formatter = new java.text.MessageFormat( getResourceString( "mode_status" ) );
        getFrame().out( formatter.format( messageArguments ) );
        return true;
    }

    public void setMenubarVisible( boolean visible )
    {
        menubarVisible = visible;
        getFrame().getFreeMindMenuBar().setVisible( menubarVisible );
    }

    public void setToolbarVisible( boolean visible )
    {
        toolbarVisible = visible;
        toolbar.setOpaque( toolbarVisible );
    }

    public void setLeftToolbarVisible( boolean visible )
    {
        if (getMode() != null && getMode().getLeftToolBar() != null) {
            leftToolbarVisible = visible;
            getMode().getLeftToolBar().setVisible( leftToolbarVisible );
        }
    }

    public freemind.controller.NodeKeyListener getNodeKeyListener()
    {
        return nodeKeyListener;
    }

    public freemind.controller.NodeMouseMotionListener getNodeMouseMotionListener()
    {
        return nodeMouseMotionListener;
    }

    public freemind.controller.MapMouseMotionListener getMapMouseMotionListener()
    {
        return mapMouseMotionListener;
    }

    public freemind.controller.MapMouseWheelListener getMapMouseWheelListener()
    {
        return mapMouseWheelListener;
    }

    public freemind.controller.NodeDragListener getNodeDragListener()
    {
        return nodeDragListener;
    }

    public freemind.controller.NodeDropListener getNodeDropListener()
    {
        return nodeDropListener;
    }

    public void setFrame( freemind.main.FreeMindMain frame )
    {
        this.frame = frame;
    }

    void moveToRoot()
    {
        if (getMapModule() != null) {
            getView().moveToRoot();
        }
    }

    public void informationMessage( java.lang.Object message )
    {
        JOptionPane.showMessageDialog( getFrame().getContentPane(), message.toString(), "FreeMind", JOptionPane.INFORMATION_MESSAGE );
    }

    public void informationMessage( java.lang.Object message, javax.swing.JComponent component )
    {
        JOptionPane.showMessageDialog( component, message.toString(), "FreeMind", JOptionPane.INFORMATION_MESSAGE );
    }

    public void errorMessage( java.lang.Object message )
    {
        JOptionPane.showMessageDialog( getFrame().getContentPane(), message.toString(), "FreeMind", JOptionPane.ERROR_MESSAGE );
    }

    public void errorMessage( java.lang.Object message, javax.swing.JComponent component )
    {
        JOptionPane.showMessageDialog( component, message.toString(), "FreeMind", JOptionPane.ERROR_MESSAGE );
    }

    public void obtainFocusForSelected()
    {
        SwingUtilities.invokeLater( new java.lang.Runnable(){
            public void run()
            {
                if (getView() != null) {
                    getView().getSelected().requestFocus();
                } else {
                    getFrame().getFreeMindMenuBar().requestFocus();
                }
            }
        } );
    }

    public void setZoom( float zoom )
    {
        getView().setZoom( zoom );
        ((freemind.controller.MainToolBar) toolbar).setZoomComboBox( zoom );
        java.lang.Object[] messageArguments = { String.valueOf( zoom * 100f ) };
        java.text.MessageFormat formatter = new java.text.MessageFormat( getResourceString( "user_defined_zoom_status_bar" ) );
        getFrame().out( formatter.format( messageArguments ) );
    }

    public void setTitle()
    {
        java.lang.Object[] messageArguments = { getMode().toString() };
        java.text.MessageFormat formatter = new java.text.MessageFormat( getResourceString( "mode_title" ) );
        java.lang.String title = formatter.format( messageArguments );
        getFrame().setTitle( title );
    }

    private void setAllActions( boolean enabled )
    {
        background.setEnabled( enabled );
        if (isPrintingAllowed) {
            print.setEnabled( enabled );
            printDirect.setEnabled( enabled );
            page.setEnabled( enabled );
        } else {
            print.setEnabled( false );
            printDirect.setEnabled( false );
            page.setEnabled( false );
        }
        close.setEnabled( enabled );
        moveToRoot.setEnabled( enabled );
        ((freemind.controller.MainToolBar) getToolBar()).setAllActions( enabled );
    }

    private void quit()
    {
        java.lang.String currentMapRestorable = getModel() != null ? getModel().getRestoreable() : null;
        while (getView() != null) {
            boolean closingNotCancelled = getMapModuleManager().close();
            if (!closingNotCancelled) {
                return;
            }
        }
        java.lang.String lastOpenedString = lastOpened.save();
        setProperty( "lastOpened", lastOpenedString );
        if (currentMapRestorable != null) {
            getFrame().setProperty( "onStartIfNotSpecified", currentMapRestorable );
        }
        setProperty( "toolbarVisible", toolbarVisible ? "true" : "false" );
        setProperty( "leftToolbarVisible", leftToolbarVisible ? "true" : "false" );
        setProperty( "antialiasEdges", antialiasEdges ? "true" : "false" );
        setProperty( "antialiasAll", antialiasAll ? "true" : "false" );
        setProperty( "appwindow_width", String.valueOf( getFrame().getWinWidth() ) );
        setProperty( "appwindow_height", String.valueOf( getFrame().getWinHeight() ) );
        setProperty( "appwindow_state", String.valueOf( getFrame().getWinState() ) );
        getFrame().saveProperties();
        System.exit( 0 );
    }

    private boolean acquirePrinterJobAndPageFormat()
    {
        if (printerJob == null) {
            try {
                printerJob = PrinterJob.getPrinterJob();
            } catch ( java.lang.SecurityException ex ) {
                isPrintingAllowed = false;
                return false;
            }
        }
        pageFormat = pageFormat == null ? printerJob.defaultPage() : pageFormat;
        return true;
    }

    public class MapModuleManager
    {

        private java.util.Map mapModules = new java.util.HashMap();

        private freemind.view.MapModule mapModule;

        private freemind.controller.Controller c;

        MapModuleManager( freemind.controller.Controller c )
        {
            this.c = c;
        }

        java.util.Map getMapModules()
        {
            return mapModules;
        }

        public freemind.view.MapModule getMapModule()
        {
            return mapModule;
        }

        public void newMapModule( freemind.modes.MindMap map )
        {
            freemind.view.MapModule mapModule = new freemind.view.MapModule( map, new freemind.view.mindmapview.MapView( map, c ), getMode() );
            setMapModule( mapModule );
            addToMapModules( mapModule.toString(), mapModule );
            history.mapChanged( mapModule );
            updateNavigationActions();
        }

        public void updateMapModuleName()
        {
            getMapModules().remove( getMapModule().toString() );
            getMapModule().rename();
            addToMapModules( getMapModule().toString(), getMapModule() );
        }

        void nextMapModule()
        {
            java.util.List keys = new java.util.LinkedList( getMapModules().keySet() );
            int index = keys.indexOf( getMapModule().toString() );
            java.util.ListIterator i = keys.listIterator( index + 1 );
            if (i.hasNext()) {
                changeToMapModule( (java.lang.String) i.next() );
            } else {
                if (keys.iterator().hasNext()) {
                    changeToMapModule( (java.lang.String) keys.iterator().next() );
                }
            }
        }

        void previousMapModule()
        {
            java.util.List keys = new java.util.LinkedList( getMapModules().keySet() );
            int index = keys.indexOf( getMapModule().toString() );
            java.util.ListIterator i = keys.listIterator( index );
            if (i.hasPrevious()) {
                changeToMapModule( (java.lang.String) i.previous() );
            } else {
                java.util.Iterator last = keys.listIterator( keys.size() - 1 );
                if (last.hasNext()) {
                    changeToMapModule( (java.lang.String) last.next() );
                }
            }
        }

        public boolean tryToChangeToMapModule( java.lang.String mapModule )
        {
            if (mapModule != null && getMapModules().containsKey( mapModule )) {
                changeToMapModule( mapModule );
                return true;
            } else {
                return false;
            }
        }

        void changeToMapModule( java.lang.String mapModule )
        {
            freemind.view.MapModule map = (freemind.view.MapModule) getMapModules().get( mapModule );
            history.mapChanged( map );
            changeToMapModuleWithoutHistory( map );
        }

        void changeToMapModuleWithoutHistory( freemind.view.MapModule map )
        {
            if (map.getMode() != getMode()) {
                changeToMode( map.getMode().toString() );
            }
            setMapModule( map );
            mapModuleChanged();
        }

        public void changeToMapOfMode( freemind.modes.Mode mode )
        {
            for (java.util.Iterator i = getMapModules().keySet().iterator(); i.hasNext();) {
                java.lang.String next = (java.lang.String) i.next();
                if (((freemind.view.MapModule) getMapModules().get( next )).getMode() == mode) {
                    changeToMapModule( next );
                    return;
                }
            }
        }

        private void mapModuleChanged()
        {
            frame.getFreeMindMenuBar().updateMapsMenu();
            lastOpened.mapOpened( getMapModule() );
            frame.getFreeMindMenuBar().updateLastOpenedList();
            setTitle();
            updateZoomBar();
            c.obtainFocusForSelected();
        }

        private void setMapModule( freemind.view.MapModule mapModule )
        {
            this.mapModule = mapModule;
            frame.setView( mapModule != null ? mapModule.getView() : null );
        }

        private void addToMapModules( java.lang.String key, freemind.view.MapModule value )
        {
            java.lang.String extension = "";
            int count = 1;
            while (mapModules.containsKey( key + extension )) {
                extension = "<" + ++count + ">";
            }
            value.setName( key + extension );
            mapModules.put( key + extension, value );
            setAllActions( true );
            moveToRoot();
            mapModuleChanged();
        }

        private void changeToAnotherMap( java.lang.String toBeClosed )
        {
            java.util.List keys = new java.util.LinkedList( getMapModules().keySet() );
            for (java.util.ListIterator i = keys.listIterator(); i.hasNext();) {
                java.lang.String key = (java.lang.String) i.next();
                if (!key.equals( toBeClosed )) {
                    changeToMapModule( key );
                    return;
                }
            }
        }

        private void updateNavigationActions()
        {
            java.util.List keys = new java.util.LinkedList( getMapModules().keySet() );
            navigationPreviousMap.setEnabled( keys.size() > 1 );
            navigationNextMap.setEnabled( keys.size() > 1 );
        }

        private void updateZoomBar()
        {
            if (getMapModule() != null) {
                ((freemind.controller.MainToolBar) c.toolbar).setZoomComboBox( getMapModule().getView().getZoom() );
            }
        }

        private boolean close()
        {
            boolean closingNotCancelled = getMode().getModeController().close();
            if (!closingNotCancelled) {
                return false;
            }
            java.lang.String toBeClosed = getMapModule().toString();
            mapModules.remove( toBeClosed );
            if (mapModules.isEmpty()) {
                setAllActions( false );
                setMapModule( null );
                frame.setView( null );
            } else {
                changeToMapModule( (java.lang.String) mapModules.keySet().iterator().next() );
                updateNavigationActions();
            }
            mapModuleChanged();
            return true;
        }

    }

    private class HistoryManager
    {

        private java.util.LinkedList historyList = new java.util.LinkedList();

        private int current;

        HistoryManager()
        {
        }

        void nextMap()
        {
            if (false) {
                if (current + 1 < historyList.size()) {
                    getMapModuleManager().changeToMapModuleWithoutHistory( (freemind.view.MapModule) historyList.get( ++current ) );
                    historyPreviousMap.setEnabled( true );
                    if (current >= historyList.size() - 1) {
                        historyNextMap.setEnabled( false );
                    }
                }
            }
        }

        void previousMap()
        {
            if (false) {
                if (current > 0) {
                    getMapModuleManager().changeToMapModuleWithoutHistory( (freemind.view.MapModule) historyList.get( --current ) );
                    historyNextMap.setEnabled( true );
                    if (current <= 0) {
                        historyPreviousMap.setEnabled( false );
                    }
                }
            }
        }

        void mapChanged( freemind.view.MapModule map )
        {
            if (false) {
                while (current < historyList.size() - 1) {
                    historyList.remove( historyList.size() - 1 );
                }
                historyList.add( map );
                current = historyList.indexOf( map );
                if (current > 0) {
                    historyPreviousMap.setEnabled( true );
                } else {
                    historyPreviousMap.setEnabled( false );
                }
                if (current < historyList.size() - 1) {
                    historyNextMap.setEnabled( true );
                } else {
                    historyNextMap.setEnabled( false );
                }
            }
        }

    }

    private class QuitAction extends javax.swing.AbstractAction
    {

        QuitAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "quit" ) );
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            quit();
        }

    }

    private class CloseAction extends javax.swing.AbstractAction
    {

        CloseAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "close" ) );
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            getMapModuleManager().close();
        }

    }

    private class PrintAction extends javax.swing.AbstractAction
    {

        freemind.controller.Controller controller;

        boolean isDlg;

        PrintAction( freemind.controller.Controller controller, boolean isDlg )
        {
            super( controller.getResourceString( "print" ), new javax.swing.ImageIcon( getResource( "images/Print24.gif" ) ) );
            this.controller = controller;
            setEnabled( false );
            this.isDlg = isDlg;
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            if (!acquirePrinterJobAndPageFormat()) {
                return;
            }
            printerJob.setPrintable( getView(), pageFormat );
            if (!isDlg || printerJob.printDialog()) {
                try {
                    printerJob.print();
                } catch ( java.lang.Exception ex ) {
                    ex.printStackTrace();
                }
            }
        }

    }

    private class PageAction extends javax.swing.AbstractAction
    {

        freemind.controller.Controller controller;

        PageAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "page" ) );
            this.controller = controller;
            setEnabled( false );
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            if (!acquirePrinterJobAndPageFormat()) {
                return;
            }
            final javax.swing.JDialog dialog = new javax.swing.JDialog( (javax.swing.JFrame) getFrame(), getResourceString( "printing_settings" ), true );
            final javax.swing.JCheckBox fitToPage = new javax.swing.JCheckBox( getResourceString( "fit_to_page" ), Tools.safeEquals( "true", getProperty( "fit_to_page" ) ) );
            final javax.swing.JLabel userZoomL = new javax.swing.JLabel( getResourceString( "user_zoom" ) );
            final javax.swing.JTextField userZoom = new javax.swing.JTextField( getProperty( "user_zoom" ), 3 );
            userZoom.setEditable( !fitToPage.isSelected() );
            final javax.swing.JButton okButton = new javax.swing.JButton( getResourceString( "ok" ) );
            final freemind.main.Tools.IntHolder eventSource = new freemind.main.Tools.IntHolder();
            javax.swing.JPanel panel = new javax.swing.JPanel();
            java.awt.GridBagLayout gridbag = new java.awt.GridBagLayout();
            java.awt.GridBagConstraints c = new java.awt.GridBagConstraints();
            eventSource.setValue( 0 );
            okButton.addActionListener( new java.awt.event.ActionListener(){
                public void actionPerformed( java.awt.event.ActionEvent e )
                {
                    eventSource.setValue( 1 );
                    dialog.dispose();
                }
            } );
            fitToPage.addItemListener( new java.awt.event.ItemListener(){
                public void itemStateChanged( java.awt.event.ItemEvent e )
                {
                    userZoom.setEditable( e.getStateChange() == ItemEvent.DESELECTED );
                }
            } );
            c.gridx = 0;
            c.gridy = 0;
            c.gridwidth = 2;
            gridbag.setConstraints( fitToPage, c );
            panel.add( fitToPage );
            c.gridy = 1;
            c.gridwidth = 1;
            gridbag.setConstraints( userZoomL, c );
            panel.add( userZoomL );
            c.gridx = 1;
            c.gridwidth = 1;
            gridbag.setConstraints( userZoom, c );
            panel.add( userZoom );
            c.gridy = 2;
            c.gridx = 0;
            c.gridwidth = 3;
            c.insets = new java.awt.Insets( 10, 0, 0, 0 );
            gridbag.setConstraints( okButton, c );
            panel.add( okButton );
            panel.setLayout( gridbag );
            dialog.setDefaultCloseOperation( JDialog.DISPOSE_ON_CLOSE );
            dialog.setContentPane( panel );
            dialog.setLocationRelativeTo( (javax.swing.JFrame) getFrame() );
            dialog.getRootPane().setDefaultButton( okButton );
            dialog.pack();
            dialog.show();
            if (eventSource.getValue() == 1) {
                setProperty( "user_zoom", userZoom.getText() );
                setProperty( "fit_to_page", fitToPage.isSelected() ? "true" : "false" );
            } else {
                return;
            }
            pageFormat = printerJob.pageDialog( pageFormat );
        }

    }

    private class DocumentationAction extends javax.swing.AbstractAction
    {

        freemind.controller.Controller controller;

        DocumentationAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "documentation" ) );
            this.controller = controller;
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            changeToMode( "Browse" );
        }

    }

    private class AboutAction extends javax.swing.AbstractAction
    {

        freemind.controller.Controller controller;

        AboutAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "about" ) );
            this.controller = controller;
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            JOptionPane.showMessageDialog( getFrame().getViewport(), controller.getResourceString( "about_text" ) + FreeMind.version );
        }

    }

    private class LicenseAction extends javax.swing.AbstractAction
    {

        freemind.controller.Controller controller;

        LicenseAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "license" ) );
            this.controller = controller;
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            JOptionPane.showMessageDialog( getView(), controller.getResourceString( "license_text" ) );
        }

    }

    private class HistoryPreviousMapAction extends javax.swing.AbstractAction
    {

        HistoryPreviousMapAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "previous_map" ), new javax.swing.ImageIcon( getResource( "images/Back24.gif" ) ) );
            setEnabled( false );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            history.previousMap();
        }

    }

    private class HistoryNextMapAction extends javax.swing.AbstractAction
    {

        HistoryNextMapAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "next_map" ), new javax.swing.ImageIcon( getResource( "images/Forward24.gif" ) ) );
            setEnabled( false );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            history.nextMap();
        }

    }

    private class NavigationPreviousMapAction extends javax.swing.AbstractAction
    {

        NavigationPreviousMapAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "previous_map" ), new javax.swing.ImageIcon( getResource( "images/Back24.gif" ) ) );
            setEnabled( false );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            mapModuleManager.previousMapModule();
        }

    }

    private class NavigationNextMapAction extends javax.swing.AbstractAction
    {

        NavigationNextMapAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "next_map" ), new javax.swing.ImageIcon( getResource( "images/Forward24.gif" ) ) );
            setEnabled( false );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            mapModuleManager.nextMapModule();
        }

    }

    private class MoveToRootAction extends javax.swing.AbstractAction
    {

        MoveToRootAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "move_to_root" ) );
            setEnabled( false );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            moveToRoot();
        }

    }

    private class ToggleMenubarAction extends javax.swing.AbstractAction
    {

        ToggleMenubarAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "toggle_menubar" ) );
            setEnabled( true );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            menubarVisible = !menubarVisible;
            setMenubarVisible( menubarVisible );
        }

    }

    private class ToggleToolbarAction extends javax.swing.AbstractAction
    {

        ToggleToolbarAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "toggle_toolbar" ) );
            setEnabled( true );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            toolbarVisible = !toolbarVisible;
            setToolbarVisible( toolbarVisible );
        }

    }

    private class ToggleLeftToolbarAction extends javax.swing.AbstractAction
    {

        ToggleLeftToolbarAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "toggle_left_toolbar" ) );
            setEnabled( true );
        }

        public void actionPerformed( java.awt.event.ActionEvent event )
        {
            leftToolbarVisible = !leftToolbarVisible;
            setLeftToolbarVisible( leftToolbarVisible );
        }

    }

    protected class ZoomInAction extends javax.swing.AbstractAction
    {

        public ZoomInAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "zoom_in" ) );
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            ((freemind.controller.MainToolBar) toolbar).zoomIn();
        }

    }

    protected class ZoomOutAction extends javax.swing.AbstractAction
    {

        public ZoomOutAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "zoom_out" ) );
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            ((freemind.controller.MainToolBar) toolbar).zoomOut();
        }

    }

    private class BackgroundSwatch extends freemind.controller.ColorSwatch
    {

        java.awt.Color getColor()
        {
            return getModel().getBackgroundColor();
        }

    }

    private class BackgroundAction extends javax.swing.AbstractAction
    {

        BackgroundAction( freemind.controller.Controller controller, javax.swing.Icon icon )
        {
            super( controller.getResourceString( "background" ), icon );
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            java.awt.Color color = JColorChooser.showDialog( getView(), "Choose Background Color:", getView().getBackground() );
            getModel().setBackgroundColor( color );
        }

    }

    private class OptionAntialiasAction extends javax.swing.AbstractAction
    {

        OptionAntialiasAction( freemind.controller.Controller controller )
        {
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            if (e.getActionCommand().equals( "antialias_none" )) {
                setAntialiasEdges( false );
                setAntialiasAll( false );
            }
            if (e.getActionCommand().equals( "antialias_edges" )) {
                setAntialiasEdges( true );
                setAntialiasAll( false );
            }
            if (e.getActionCommand().equals( "antialias_all" )) {
                setAntialiasEdges( false );
                setAntialiasAll( true );
            }
            if (getView() != null) {
                getView().repaint();
            }
        }

    }

    private class OptionHTMLExportFoldingAction extends javax.swing.AbstractAction
    {

        OptionHTMLExportFoldingAction( freemind.controller.Controller controller )
        {
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            setProperty( "html_export_folding", e.getActionCommand() );
        }

    }

    private class OptionSelectionMechanismAction extends javax.swing.AbstractAction
    {

        freemind.controller.Controller c;

        OptionSelectionMechanismAction( freemind.controller.Controller controller )
        {
            c = controller;
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            setProperty( "selection_method", e.getActionCommand() );
            freemind.controller.NodeMouseMotionListener.updateSelectionMethod( c );
            java.lang.String statusBarString = c.getResourceString( e.getActionCommand() );
            if (statusBarString != null) {
                c.getFrame().out( statusBarString );
            }
        }

    }

    private class OpenFAQAction extends javax.swing.AbstractAction
    {

        freemind.controller.Controller c;

        OpenFAQAction( freemind.controller.Controller controller )
        {
            super( controller.getResourceString( "FAQ" ), new javax.swing.ImageIcon( controller.getResource( "images/Link.png" ) ) );
            c = controller;
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            try {
                c.getFrame().openDocument( new java.net.URL( "http://freemind.sourceforge.net/faq.html" ) );
            } catch ( java.net.MalformedURLException ex ) {
                c.errorMessage( c.getResourceString( "url_error" ) + "\n" + ex );
            } catch ( java.lang.Exception ex ) {
                c.errorMessage( ex );
            }
        }

    }

}
